package com.r3chess;

public class c0_chess {

// Chess logic module
// Board, moves
// Not fast but working
// no clock, no chess engine
// Author: mail: grozny0   at  gmail.com
	
	c0_chess()
	{
		c0_set_start_position("");
		//SAMPLES();
	}
	
String c0_position="";
int c0_sidemoves=1;

private boolean c0_wKingmoved = false;
private boolean c0_bKingmoved = false;
private boolean c0_wLRockmoved = false;
private boolean c0_wRRockmoved = false;
private boolean c0_bLRockmoved = false;
private boolean c0_bRRockmoved = false;
private boolean c0_w00 = false;
private boolean c0_b00 = false;

private int c0_lastmovepawn = 0;

String c0_become="";
String c0_become_from_engine="";			// just engine

String c0_moveslist = "";

String c0_foundmove = "";


String c0_start_FEN="";
private boolean c0_fischer=false;
private String c0_fischer_cst="";


//PGN variables
String PGN_text="";					// The game data will be here....

private String c0_PG_1="";
private String c0_PG_2="";

private String[] c0_PGN_header = new String[20];
private int c0_PGN_head_cnt = 0;

private boolean c0_PGN_short=false;
private String c0_PG_sh="";


boolean c0_errflag=false;



private String substr( String s, int from, int len )
{
	String r = "";
	if( from>=0 && s.length()>from )
	{
		try{ r = s.substring(from, from+len); }
		catch (IndexOutOfBoundsException e)
		{ r = s.substring(from); }
	}
	return r;
}
//from+len> s.length() ? s.substring(from, from+len) : s.substring(from))
private String substr( String s, int from )
{ return ( from>=0 && s.length()>from ? s.substring(from) : "" ); }
private String String_fromCharCode( int c )
{ return "" + (char)c; }
private int parseInt( String s )
{ 
	int i=0;
	try{
		i=Integer.parseInt(s);
		}
	catch( NumberFormatException e ){}
	return i;
}
private String toString( int i )
{ return String.valueOf(i); }
private int charCodeAt(String s, int at)
{ return (int)s.charAt(at); }
private String c0_ReplaceAll( String s, String s1, String s2)
{ return s.replace(s1,s2); }


//----------------------------------------------------------------------------------------------------------------------------------------------------------------------
// set up starting position...
//----------------------------------------------------------------------------------------------------------------------------------------------------------------------
void c0_set_start_position( String c0_mlist )
{

if( c0_start_FEN.length()>0 )
	{
	c0_set_FEN( c0_start_FEN );
	if(c0_fischer) c0_fischer_adjustmoved();
	}
else
	{
	c0_position = "wpa2;wpb2;wpc2;wpd2;wpe2;wpf2;wpg2;wph2;" +
		"wRa1;wNb1;wBc1;wQd1;wKe1;wBf1;wNg1;wRh1;" +
		"bpa7;bpb7;bpc7;bpd7;bpe7;bpf7;bpg7;bph7;" +
		"bRa8;bNb8;bBc8;bQd8;bKe8;bBf8;bNg8;bRh8;";
	}

c0_wKingmoved = false;
c0_bKingmoved = false;
c0_wLRockmoved = false;
c0_wRRockmoved = false;
c0_bLRockmoved = false;
c0_bRRockmoved = false;
c0_w00 = false;
c0_b00 = false;

c0_lastmovepawn = 0;
c0_sidemoves = 1;


c0_become="";
c0_become_from_engine="";			// just engine

c0_moveslist = "";

if(c0_mlist.length()>0)
	{
	for(int c0_z=0;c0_z<c0_mlist.length();c0_z+=4)
		{
		String c0_from_at=substr(c0_mlist,c0_z,2);
		String c0_to_at=substr(c0_mlist,c0_z+2,2);
		if(c0_z+4<c0_mlist.length() && substr(c0_mlist,c0_z+4,1).equals("["))
			{
			c0_become_from_engine=substr(c0_mlist,c0_z+5,1);
			c0_z+=3;
			}
		else c0_become_from_engine="";

		if(c0_fischer) c0_fischer_cstl_move(c0_from_at+c0_to_at);		
		else c0_moveto(c0_convH888(c0_from_at), c0_convH888(c0_to_at));
		c0_sidemoves=-c0_sidemoves;
		}
	if( c0_start_FEN.length()>0 )
		{
		c0_set_board_situation( c0_position, c0_wKingmoved, c0_wLRockmoved, c0_wRRockmoved, c0_w00, c0_bKingmoved, c0_bLRockmoved, c0_bRRockmoved, c0_b00, c0_lastmovepawn, c0_moveslist, c0_sidemoves );
		}
	else
		{
		String c0_pos2=c0_position;
		c0_position="";
		for(int c0_q=0;c0_q<c0_pos2.length();c0_q+=5) c0_add_piece(substr(c0_pos2,c0_q,4));
		}
	}

c0_moveslist = c0_mlist;
}

//----------------------------------------------------------------------------------------------------------------------------------------------------------------------
// Set board situation...
//----------------------------------------------------------------------------------------------------------------------------------------------------------------------
void c0_set_board_situation( String c0_figlist, boolean c0_wK, boolean c0_wLR,
		boolean c0_wRR, boolean c0_w_00, boolean c0_bK,
		boolean c0_bLR, boolean c0_bRR, boolean c0_b_00,
		int c0_elpas, String c0_ml, int c0_s )
{

c0_position="";
for( int i=0; i<c0_figlist.length(); )
	{
	c0_add_piece( substr(c0_figlist,i,4) );
	i+=4; if( i<c0_figlist.length() && substr(c0_figlist,i,1).equals(";") ) i++;
	}

c0_wKingmoved = c0_wK;
c0_bKingmoved = c0_bK;
c0_wLRockmoved = c0_wLR;
c0_wRRockmoved = c0_wRR;
c0_bLRockmoved = c0_bLR;
c0_bRRockmoved = c0_bRR;
c0_w00 = c0_w_00;
c0_b00 = c0_b_00;

c0_lastmovepawn = c0_elpas;

c0_become="";
c0_become_from_engine="";			// just engine

c0_moveslist = c0_ml;
c0_sidemoves=c0_s;
}


//----------------------------------------------------------------------------------------------------------------------------------------------------------------------
// add a piece at position...
//----------------------------------------------------------------------------------------------------------------------------------------------------------------------
void c0_add_piece( String c0_pstring )
{
String c0_1_at = substr(c0_pstring,2,2);

if(c0_position.indexOf(c0_1_at)>=0) return;

c0_position+=c0_pstring+";";
}

//----------------------------------------------------------------------------------------------------------------------------------------------------------------------
// remove a piece from position...
//----------------------------------------------------------------------------------------------------------------------------------------------------------------------
void c0_clear_at( String c0_1_at )
{
int c0_a=c0_position.indexOf(c0_1_at);
if(c0_a>=0) c0_position=substr(c0_position,0,c0_a-2) + substr(c0_position,c0_a+3);
}

//----------------------------------------------------------------------------------------------------------------------------------------------------------------------
// move a piece...
//----------------------------------------------------------------------------------------------------------------------------------------------------------------------
void c0_just_move_piece( String c0_2_from, String c0_2_to )
{
c0_clear_at( c0_2_to );
int c0_a=c0_position.indexOf(c0_2_from);
if(c0_a>=0)
	{
	c0_position=c0_position.replace( c0_2_from, c0_2_to );
	}
}

String c0_convE2(int c0_vertikali, int c0_horizontali)
{
return String_fromCharCode(96+c0_horizontali)+toString(c0_vertikali);
}

//-------------------------------------------------
String c0_convE777(String c0_verthoriz)
{
return String_fromCharCode(96+parseInt(substr(c0_verthoriz,1,1)))+substr(c0_verthoriz,0,1);
}

//-------------------------------------------------
String c0_conv52(int c0_vertikali, int c0_horizontali)
{
return toString(c0_vertikali)+toString(c0_horizontali);
}

//-------------------------------------------------
String c0_convH888(String c0_at8)
{
int c0_8horiz=charCodeAt(c0_at8,0) - 96;
int c0_8vert=parseInt(substr(c0_at8,1,1));
return toString(c0_8vert) + toString(c0_8horiz);
}

void c0_move_to(String c0_Zstr1, String c0_Zstr2 )
{
c0_moveto( c0_convH888(c0_Zstr1), c0_convH888(c0_Zstr2) );
}


//-------------------------------------------------
void c0_moveto( String c0_from_at, String c0_to_at )
{
 int c0_vert = parseInt(substr(c0_from_at,0,1));
 int c0_horiz= parseInt(substr(c0_from_at,1,1));
 int c0_vert2 = parseInt(substr(c0_to_at,0,1));
 int c0_horiz2= parseInt(substr(c0_to_at,1,1));

 int c0_p=c0_position.indexOf( c0_convE2(c0_vert,c0_horiz) );
 String c0_color=substr(c0_position,c0_p-2,1);
 String c0_figure=substr(c0_position,c0_p-1,1);

 c0_lastmovepawn = 0; 

 int c0_p2=c0_position.indexOf( c0_convE2(c0_vert2,c0_horiz2) );
 if(c0_p2>=0)
  {
   c0_position = substr(c0_position, 0,c0_p2-2) + substr(c0_position, c0_p2+3);
   
   if(!c0_wLRockmoved && c0_convE2(c0_vert2,c0_horiz2).equals("a1")) c0_wLRockmoved=true;
   if(!c0_wRRockmoved && c0_convE2(c0_vert2,c0_horiz2).equals("h1")) c0_wRRockmoved=true;
   if(!c0_bLRockmoved && c0_convE2(c0_vert2,c0_horiz2).equals("a8")) c0_bLRockmoved=true;
   if(!c0_bRRockmoved && c0_convE2(c0_vert2,c0_horiz2).equals("h8")) c0_bRRockmoved=true;
 
  }
 else
  {		
   if(c0_figure.equals("R"))
    {
     if(c0_color.equals("w"))
	{
	 if(c0_convE2(c0_vert,c0_horiz).equals("a1")) c0_wLRockmoved=true;
	 if(c0_convE2(c0_vert,c0_horiz).equals("h1")) c0_wRRockmoved=true;
	}
     else
	{
	 if(c0_convE2(c0_vert,c0_horiz).equals("a8")) c0_bLRockmoved=true;
	 if(c0_convE2(c0_vert,c0_horiz).equals("h8")) c0_bRRockmoved=true;
	}
    }
   
	
   if(c0_figure.equals("K"))
    {
    if(!c0_wKingmoved && c0_color.equals("w"))
	{
	if(c0_convE2(c0_vert,c0_horiz).equals("e1") &&
				c0_convE2(c0_vert2,c0_horiz2).equals("g1"))	// 0-0
		{
		c0_position = c0_position.replace( "h1", "f1" );		// Rf1
		c0_w00 = true;
		c0_become="0";
		}
	if(c0_convE2(c0_vert,c0_horiz).equals("e1") &&
			c0_convE2(c0_vert2,c0_horiz2).equals("c1"))	// 0-0-0
		{
		c0_position = c0_position.replace( "a1", "d1" );		// Rd1
		c0_w00 = true;
		c0_become="0";
		}
	c0_wKingmoved=true;
	}
    if(!c0_bKingmoved && c0_color.equals("b"))
	{
	if(c0_convE2(c0_vert,c0_horiz).equals("e8") &&
			c0_convE2(c0_vert2,c0_horiz2).equals("g8"))	// 0-0
		{
		c0_position = c0_position.replace( "h8", "f8" );		// Rf8
		c0_b00 = true;
		c0_become="0";
		}
	if(c0_convE2(c0_vert,c0_horiz).equals("e8") &&
			c0_convE2(c0_vert2,c0_horiz2).equals("c8"))	// 0-0-0
		{
		c0_position = c0_position.replace( "a8", "d8" );		// Rd8
		c0_b00 = true;
		c0_become="0";
		}
	c0_bKingmoved=true;
	}
    }	
  }

 if(c0_figure.equals("p"))		// pawn
	{
	 if(c0_vert2==8 || c0_vert2==1)
		{
		if(c0_become_from_engine.length()>0)
		 {
		  c0_figure= c0_become_from_engine;
		 }
		else
		 {
		 c0_figure="Q";
		 }
		c0_become=c0_figure;

		c0_position = c0_position.replace( "p"+c0_convE2(c0_vert,c0_horiz), c0_figure+c0_convE2(c0_vert,c0_horiz) );
		}
	 if(c0_p2<0 && c0_horiz!=c0_horiz2)
		{
		int c0_p3=c0_position.indexOf( c0_convE2(c0_vert,c0_horiz2) );
		c0_position = substr(c0_position, 0,c0_p3-2) + substr(c0_position, c0_p3+3);
		}
	 if((c0_vert==2 && c0_vert2==4) || (c0_vert==7 && c0_vert2==5)) c0_lastmovepawn = c0_horiz;
	}

 c0_position = c0_position.replace( c0_convE2(c0_vert,c0_horiz), c0_convE2(c0_vert2,c0_horiz2) );

 c0_moveslist += c0_convE2(c0_vert,c0_horiz) + c0_convE2(c0_vert2,c0_horiz2) +
		 ( ( (c0_become.length()==0) || (c0_become.equals("Q")) ||
				 (c0_become.equals("0")) ) ? "": "["+c0_become+"]" );

}

//-------------------------------------------------
String c0_D_last_move_was()
{
String c0_ret="";
if( c0_moveslist.length()>0 )
 {
 if ( substr( c0_moveslist, c0_moveslist.length()-1, 1 ).equals("]") )
	 	c0_ret= substr( c0_moveslist, c0_moveslist.length()-7, 7 );
 else c0_ret= substr( c0_moveslist, c0_moveslist.length()-4, 4 );
 }
return c0_ret;
}

//-------------------------------------------------
void c0_take_back()
{
String c0_movespre="";
if( c0_moveslist.length()>0 )
 {
 if ( substr(c0_moveslist, c0_moveslist.length()-1, 1 ).equals("]") )
	 	c0_movespre= substr(c0_moveslist, 0, c0_moveslist.length()-7 );
 else c0_movespre= substr(c0_moveslist, 0, c0_moveslist.length()-4 );
 }

c0_set_start_position( c0_movespre );
}


//-------------------------------------------------
boolean c0_D_is_empty(String c0_Zstr)
{
String c0_Zs2=c0_convH888(c0_Zstr);
return c0_is_empty( parseInt(substr(c0_Zs2,0,1)), parseInt(substr(c0_Zs2,1,1)));
}

//-------------------------------------------------
boolean c0_is_empty(int c0_Zvert, int c0_Zhoriz)
{
 boolean c0_good = true;
 if(c0_Zvert<1 || c0_Zvert>8 || c0_Zhoriz<1 || c0_Zhoriz>8) c0_good=false;
 else
  {
   int c0_pz2=c0_position.indexOf( c0_convE2(c0_Zvert,c0_Zhoriz) );
   if(c0_pz2>=0) c0_good=false;
  }
 return c0_good;
}


//-------------------------------------------------
String c0_D_what_at(String c0_Zstr1)
{
 String c0_ret="";
 int c0_pz2=c0_position.indexOf( c0_Zstr1 );
 if(c0_pz2>=0) c0_ret=substr(c0_position,c0_pz2-2,2);
 return c0_ret;
}


//-------------------------------------------------
boolean c0_D_is_enemy(String c0_Zstr, String c0_mycolor)
{
String c0_Zs2=c0_convH888(c0_Zstr);
return c0_is_enemy( parseInt(substr(c0_Zs2,0,1)),
		parseInt(substr(c0_Zs2,1,1)), c0_mycolor);
}


//-------------------------------------------------
boolean c0_is_enemy(int c0_Zvert, int c0_Zhoriz, String c0_mycolor)
{
 boolean c0_is_there =false;
 if(c0_Zvert>=1 && c0_Zvert<=8 && c0_Zhoriz>=1 && c0_Zhoriz<=8)
  {
   int c0_pz2=c0_position.indexOf( c0_convE2(c0_Zvert,c0_Zhoriz) );

   if(c0_pz2>=0 && !substr(c0_position,c0_pz2-2,1).equals(c0_mycolor)) c0_is_there=true;
  }
 return c0_is_there;
}


//-------------------------------------------------
boolean c0_D_is_emptyline(String c0_Zstr1, String c0_Zstr2 )
{
String c0_Zs1=c0_convH888(c0_Zstr1);
String c0_Zs2=c0_convH888(c0_Zstr2);
return c0_is_emptyline( parseInt(substr(c0_Zs1,0,1)),
		parseInt(substr(c0_Zs1,1,1)) , parseInt(substr(c0_Zs2,0,1)),
		parseInt(substr(c0_Zs2,1,1)));
}

//-------------------------------------------------
boolean c0_is_emptyline(int c0_Zvert, int c0_Zhoriz, int c0_Zvert2, int c0_Zhoriz2)
{
 boolean c0_good = true;
 int c0_DZvert=c0_Zvert2-c0_Zvert; if(c0_DZvert<0) c0_DZvert=-1; else if(c0_DZvert>0) c0_DZvert=1;
 int c0_DZhoriz=c0_Zhoriz2-c0_Zhoriz; if(c0_DZhoriz<0) c0_DZhoriz=-1; else if(c0_DZhoriz>0) c0_DZhoriz=1;
 int c0_PZvert=c0_Zvert+c0_DZvert;
 int c0_PZhoriz=c0_Zhoriz+c0_DZhoriz;
 for(;c0_PZvert!=c0_Zvert2 || c0_PZhoriz!=c0_Zhoriz2;)
	{
	if( !c0_is_empty( c0_PZvert, c0_PZhoriz ) )
		{
		 c0_good=false;
		 break;
		}		
	c0_PZvert+=c0_DZvert;
	c0_PZhoriz+=c0_DZhoriz;
	}
 return c0_good;
}


//-------------------------------------------------
boolean c0_D_is_check_to_king(String c0_ZKcolor)
{
return c0_is_check_to_king(c0_ZKcolor);
}

//-------------------------------------------------
boolean c0_is_check_to_king(String c0_ZKcolor)
{
 boolean c0_is_check=false;
 int c0_Zp=c0_position.indexOf(c0_ZKcolor+"K");
 int c0_ZKhoriz=charCodeAt(substr(c0_position,c0_Zp+2,1), 0) - 96;
 int c0_ZKvert=parseInt(substr(c0_position,c0_Zp+3,1));
 String c0_ZK_at = toString(c0_ZKvert) + toString(c0_ZKhoriz);

 for(int c0_i=0;c0_position.length()>c0_i; c0_i+=5)
	{
	String c0_Zcolor=substr(c0_position,c0_i,1);
	
	if(!c0_Zcolor.equals(c0_ZKcolor))
		{
		 int c0_Zhoriz=charCodeAt(substr(c0_position,c0_i+2,1),0) - 96;
		 int c0_Zvert=parseInt(substr(c0_position,c0_i+3,1));
		 String c0_Z_at = toString(c0_Zvert) + toString(c0_Zhoriz);

		 if(c0_can_be_moved( c0_Z_at, c0_ZK_at, true))
			{
			 c0_is_check=true;
			 break;
			}
		}
	}
 return c0_is_check;
}


//-------------------------------------------------
boolean c0_is_attacked_king_before_move (String c0_Qfrom_at, String c0_Qto_at,
		String c0_Qcolor)
{
  boolean c0_is_attack=false;

  String c0_save_position=c0_position;
  int c0_save_sidemoves=c0_sidemoves;
  boolean c0_save_wKingmoved=c0_wKingmoved;
  boolean c0_save_bKingmoved=c0_bKingmoved;
  boolean c0_save_wLRockmoved=c0_wLRockmoved;
  boolean c0_save_wRRockmoved=c0_wRRockmoved;
  boolean c0_save_bLRockmoved=c0_bLRockmoved;
  boolean c0_save_bRRockmoved=c0_bRRockmoved;
  boolean c0_save_w00=c0_w00;
  boolean c0_save_b00=c0_b00;
  String c0_save_become=c0_become;
  String c0_save_moveslist=c0_moveslist;

  int c0_save_lastmovepawn=c0_lastmovepawn;

  c0_moveto(c0_Qfrom_at, c0_Qto_at);
  c0_sidemoves=-c0_sidemoves;

  if( c0_is_check_to_king(c0_Qcolor) )
	{
	c0_is_attack=true;
	}

  c0_position=c0_save_position;
  c0_sidemoves=c0_save_sidemoves;
  c0_wKingmoved=c0_save_wKingmoved;
  c0_bKingmoved=c0_save_bKingmoved;
  c0_wLRockmoved=c0_save_wLRockmoved;
  c0_wRRockmoved=c0_save_wRRockmoved;
  c0_bLRockmoved=c0_save_bLRockmoved;
  c0_bRRockmoved=c0_save_bRRockmoved;
  c0_lastmovepawn=c0_save_lastmovepawn;
  c0_w00=c0_save_w00;
  c0_b00=c0_save_b00;
  c0_become=c0_save_become;
  c0_moveslist=c0_save_moveslist;

  return c0_is_attack;
}


//-------------------------------------------------
boolean c0_D_is_mate_to_king(String c0_ZKcolor)
{
return c0_is_mate_to_king(c0_ZKcolor, false);
}

//-------------------------------------------------
boolean c0_is_mate_to_king(String c0_ZKcolor, boolean c0_just_mate)
{
 boolean c0_is_mate=false;

 if( c0_just_mate || c0_is_check_to_king(c0_ZKcolor) )
  {
   c0_is_mate=true;
   for(int c0_i=0;c0_is_mate && c0_position.length()>c0_i; c0_i+=5)
	{
	String c0_Zcolor=substr(c0_position,c0_i,1);
	if(c0_Zcolor.equals(c0_ZKcolor))
		{
		 int c0_Zhoriz=charCodeAt(substr(c0_position,c0_i+2,1),0) - 96;
		 int c0_Zvert=parseInt(substr(c0_position,c0_i+3,1));
		 String c0_Z_at = toString(c0_Zvert) + toString(c0_Zhoriz);
		 for(int c0_vi=1;c0_is_mate && c0_vi<=8;c0_vi++)
		  for(int c0_vj=1;c0_is_mate && c0_vj<=8;c0_vj++)
			{
			String c0_Z_to_at=toString(c0_vi)+toString(c0_vj);
			if(c0_can_be_moved( c0_Z_at, c0_Z_to_at, false))
				{
				 c0_is_mate=false;
				 break;
				}
			}
		}
	}

  } 
 return c0_is_mate;
}

//-------------------------------------------------
boolean c0_D_is_stalemate_to_king(String c0_ZWcolor)
{
return c0_is_pate_to_king(c0_ZWcolor) && (!c0_is_mate_to_king(c0_ZWcolor, false));
}

//-------------------------------------------------
boolean c0_is_pate_to_king(String c0_ZWcolor)
{
 boolean c0_is_pate=true;

 for(int c0_j=0;c0_is_pate && c0_position.length()>c0_j; c0_j+=5)
	{
	String c0_Wcolor=substr(c0_position,c0_j,1);
	if(c0_Wcolor.equals(c0_ZWcolor))
		{
		 int c0_Whoriz=charCodeAt(substr(c0_position,c0_j+2,1),0) - 96;
		 int c0_Wvert=parseInt(substr(c0_position,c0_j+3,1));
		 String c0_W_at = toString(c0_Wvert) + toString(c0_Whoriz);
		 for(int c0_wi=1;c0_is_pate && c0_wi<=8;c0_wi++)
		  for(int c0_wj=1;c0_is_pate && c0_wj<=8;c0_wj++)
			{
			String c0_W_to_at=toString(c0_wi)+toString(c0_wj);
			if(c0_can_be_moved( c0_W_at, c0_W_to_at, false))
				{
				 c0_is_pate=false;
				 break;
				}
			}
		}
	}

 return c0_is_pate;
}


//-------------------------------------------------
boolean c0_D_can_be_moved(String c0_Zstr1, String c0_Zstr2)
{
return c0_can_be_moved( c0_convH888(c0_Zstr1), c0_convH888(c0_Zstr2), false);
}


//-------------------------------------------------
boolean c0_can_be_moved(String c0_from_at, String c0_to_at, boolean c0_just_move_or_eat)
{
 boolean c0_can = false;
 int c0_vert = parseInt(substr(c0_from_at,0,1));		
 int c0_horiz= parseInt(substr(c0_from_at,1,1));
 int c0_vert2 = parseInt(substr(c0_to_at,0,1));
 int c0_horiz2= parseInt(substr(c0_to_at,1,1));

 int c0_p=c0_position.indexOf( c0_convE2(c0_vert,c0_horiz) );
 String c0_color=substr(c0_position,c0_p-2,1);
 String c0_figure=substr(c0_position,c0_p-1,1);

 if(c0_is_empty(c0_vert2,c0_horiz2) || c0_is_enemy(c0_vert2,c0_horiz2,c0_color))
 {
 int c0_Dvert=c0_vert2-c0_vert; if(c0_Dvert<0) c0_Dvert=-c0_Dvert;
 int c0_Dhoriz=c0_horiz2-c0_horiz; if(c0_Dhoriz<0) c0_Dhoriz=-c0_Dhoriz;

 if(c0_figure.equals("p"))
	{
	int c0_virziens;
	if( c0_color.equals("w")) c0_virziens=1; else c0_virziens=-1;
	if(c0_horiz2==c0_horiz)
	 {
	  if( (c0_vert2==c0_vert+c0_virziens && c0_is_empty(c0_vert2,c0_horiz2)) ||
	   (c0_color.equals("w") && c0_vert2==4 && c0_vert==2 && c0_is_empty(3,c0_horiz2) && c0_is_empty(4,c0_horiz2)) ||
	   (c0_color.equals("b") && c0_vert2==5 && c0_vert==7 && c0_is_empty(5,c0_horiz2) && c0_is_empty(6,c0_horiz2)) )
		c0_can = true;
	 }
	else
	 {
	  if( (c0_horiz2==c0_horiz+1 || c0_horiz2==c0_horiz-1) && c0_vert2==c0_vert+c0_virziens)
	    if(c0_is_enemy(c0_vert2,c0_horiz2,c0_color) ||
		 (c0_lastmovepawn==c0_horiz2 && 
			((c0_color.equals("w") && c0_vert2==6) || (c0_color.equals("b") && c0_vert2==3)) ) ) c0_can=true;
	 }
	}
 if(c0_figure.equals("N"))
	{
	if( c0_Dvert+c0_Dhoriz==3 && c0_Dvert!=0 && c0_Dhoriz!=0 ) c0_can=true;
	}
 if(c0_figure.equals("B"))
	{
	if( (c0_Dvert>0 && c0_Dvert==c0_Dhoriz) && c0_is_emptyline(c0_vert,c0_horiz,c0_vert2,c0_horiz2)) c0_can=true;			
	}
 if(c0_figure.equals("R"))
	{
	if( ((c0_Dvert==0||c0_Dhoriz==0) && c0_Dvert!=c0_Dhoriz) && c0_is_emptyline(c0_vert,c0_horiz,c0_vert2,c0_horiz2)) c0_can=true;	
	}
 if(c0_figure.equals("Q"))
	{
	if( (c0_Dvert==0||c0_Dhoriz==0||c0_Dvert==c0_Dhoriz) && c0_is_emptyline(c0_vert,c0_horiz,c0_vert2,c0_horiz2)) c0_can=true;	
	}
 if(c0_figure.equals("K"))
	{
	if((c0_Dvert==0 && c0_Dhoriz==1)||(c0_Dhoriz==0 && c0_Dvert==1)||(c0_Dhoriz==1 && c0_Dvert==1)) c0_can=true;
	else 
	 if (!c0_just_move_or_eat && !c0_is_check_to_king(c0_color) && (!c0_fischer))
		{
		if(c0_color.equals("w"))
		 {
		  if(!c0_wKingmoved && c0_vert==1 && c0_horiz==5 && c0_vert2==1)
			{
			if( (c0_horiz2==7 && !c0_wRRockmoved &&
				c0_is_empty(1,6) && c0_is_empty(1,7) &&
				!c0_is_attacked_king_before_move("15", "16", c0_color) &&
				!c0_is_attacked_king_before_move("15", "17", c0_color)) ||
			    (c0_horiz2==3 && !c0_wLRockmoved &&
				c0_is_empty(1,2) && c0_is_empty(1,3) && c0_is_empty(1,4) &&
				!c0_is_attacked_king_before_move("15", "14", c0_color) &&
				!c0_is_attacked_king_before_move("15", "13", c0_color)) ) c0_can=true;
			}
		 }
		else
		 {
		  if(!c0_bKingmoved && c0_vert==8 && c0_horiz==5 && c0_vert2==8)
			{
			if( (c0_horiz2==7 && !c0_bRRockmoved &&
				c0_is_empty(8,6) && c0_is_empty(8,7) &&
				!c0_is_attacked_king_before_move("85", "86", c0_color) &&
				!c0_is_attacked_king_before_move("85", "87", c0_color)) ||
			    (c0_horiz2==3 && !c0_bLRockmoved &&
				c0_is_empty(8,2) && c0_is_empty(8,3) && c0_is_empty(8,4) &&
				!c0_is_attacked_king_before_move("85", "84", c0_color) &&
				!c0_is_attacked_king_before_move("85", "83", c0_color)) ) c0_can=true;
			}
		 }
		}
	}
 if(!c0_just_move_or_eat && c0_can)
 {
  c0_can = !c0_is_attacked_king_before_move(c0_from_at, c0_to_at, c0_color);
 }
 }
 return c0_can;
}

//---------------------------------------
//  Function to get next possible moves
//---------------------------------------
String c0_get_next_moves()
{
 String c0_Dposs="";
 for(int c0_Da=0;c0_position.length()>c0_Da; c0_Da+=5)
	{
	String c0_Dcolor=substr(c0_position,c0_Da,1);
	if((c0_sidemoves>0 && c0_Dcolor.equals("w"))||(c0_sidemoves<0 && c0_Dcolor.equals("b")))
		{
		String c0_Dfigure=substr(c0_position,c0_Da+1,1);
		int c0_Dhoriz=charCodeAt(substr(c0_position,c0_Da+2,1),0) - 96;
		int c0_Dvert=parseInt(substr(c0_position,c0_Da+3,1));
		String c0_Dfrom_move=toString(c0_Dvert)+toString(c0_Dhoriz);

		if(c0_Dfigure.equals("p"))
			{
			 c0_Dposs+=c0_DCN(c0_Dfrom_move,+c0_sidemoves,0,1);
			 c0_Dposs+=c0_DCN(c0_Dfrom_move,+(2*c0_sidemoves),0,1);
			 c0_Dposs+=c0_DCN(c0_Dfrom_move,+c0_sidemoves,+1,1);
			 c0_Dposs+=c0_DCN(c0_Dfrom_move,+c0_sidemoves,-1,1);
			}
		if(c0_Dfigure.equals("N"))
			{
			 c0_Dposs+=c0_DCN(c0_Dfrom_move,+2,+1,1);
			 c0_Dposs+=c0_DCN(c0_Dfrom_move,+2,-1,1);
			 c0_Dposs+=c0_DCN(c0_Dfrom_move,+1,+2,1);
			 c0_Dposs+=c0_DCN(c0_Dfrom_move,+1,-2,1);
			 c0_Dposs+=c0_DCN(c0_Dfrom_move,-1,+2,1);
			 c0_Dposs+=c0_DCN(c0_Dfrom_move,-1,-2,1);
			 c0_Dposs+=c0_DCN(c0_Dfrom_move,-2,+1,1);
			 c0_Dposs+=c0_DCN(c0_Dfrom_move,-2,-1,1);
			}
		if(c0_Dfigure.equals("B") || c0_Dfigure.equals("Q"))
			{
			 c0_Dposs+=c0_DCN(c0_Dfrom_move,+1,+1,8);
			 c0_Dposs+=c0_DCN(c0_Dfrom_move,+1,-1,8);
			 c0_Dposs+=c0_DCN(c0_Dfrom_move,-1,+1,8);
			 c0_Dposs+=c0_DCN(c0_Dfrom_move,-1,-1,8);
			}
		if(c0_Dfigure.equals("R") || c0_Dfigure.equals("Q"))
			{
			 c0_Dposs+=c0_DCN(c0_Dfrom_move,+1,0,8);
			 c0_Dposs+=c0_DCN(c0_Dfrom_move,-1,0,8);
			 c0_Dposs+=c0_DCN(c0_Dfrom_move,0,+1,8);
			 c0_Dposs+=c0_DCN(c0_Dfrom_move,0,-1,8);
			}
		if(c0_Dfigure.equals("K"))
			{
			 c0_Dposs+=c0_DCN(c0_Dfrom_move,+1,+1,1);
			 c0_Dposs+=c0_DCN(c0_Dfrom_move,+1,0,1);
			 c0_Dposs+=c0_DCN(c0_Dfrom_move,+1,-1,1);
			 c0_Dposs+=c0_DCN(c0_Dfrom_move,0,+1,1);
			 c0_Dposs+=c0_DCN(c0_Dfrom_move,0,-1,1);
			 c0_Dposs+=c0_DCN(c0_Dfrom_move,-1,+1,1);
			 c0_Dposs+=c0_DCN(c0_Dfrom_move,-1,0,1);
			 c0_Dposs+=c0_DCN(c0_Dfrom_move,-1,-1,1);	
			 if((c0_Dcolor.equals("w") && c0_Dfrom_move.equals("15")) ||
					 (c0_Dcolor.equals("b") && c0_Dfrom_move.equals("85")))
				{
				 c0_Dposs+=c0_DCN(c0_Dfrom_move,0,-2,1);	
				 c0_Dposs+=c0_DCN(c0_Dfrom_move,0,+2,1);	
				}
			}
		}
	}
 return c0_Dposs;
}


//---------------------------------------
//
String c0_DCN(String c0_D7from_at, int c0_Dvert_TX, int c0_Dhoriz_TX, int c0_Dcntx)
{
 String c0_D7poss="";

 int saveD1sidemoves=c0_sidemoves;
 boolean saveD1wKingmoved=c0_wKingmoved;
 boolean saveD1bKingmoved=c0_bKingmoved;
 boolean saveD1wLRockmoved=c0_wLRockmoved;
 boolean saveD1wRRockmoved=c0_wRRockmoved;
 boolean saveD1bLRockmoved=c0_bLRockmoved;
 boolean saveD1bRRockmoved=c0_bRRockmoved;
 boolean saveD1w00=c0_w00;
 boolean saveD1b00=c0_b00;
 int saveD1lastmovepawn=c0_lastmovepawn;
 String saveD1position=c0_position;		
 String saveD1become=c0_become;

 int c0_D7vert=parseInt(substr(c0_D7from_at,0,1));
 int c0_D7horiz=parseInt(substr(c0_D7from_at,1,1));

 for(int c0_Dj=0; c0_Dj<c0_Dcntx; c0_Dj++)
  {
   c0_D7vert+=c0_Dvert_TX;
   c0_D7horiz+=c0_Dhoriz_TX;
   if(c0_D7vert>=1 && c0_D7vert<=8 && c0_D7horiz>=1 && c0_D7horiz<=8)
    {
	String c0_D7to_at=toString(c0_D7vert)+toString(c0_D7horiz);

	if( c0_can_be_moved( c0_D7from_at, c0_D7to_at, false ) )
		{
		c0_foundmove = c0_convE777( c0_D7from_at ) + c0_convE777( c0_D7to_at );
		c0_D7poss+=c0_foundmove + ",";
		}

	c0_sidemoves=saveD1sidemoves;
	c0_wKingmoved=saveD1wKingmoved;
	c0_bKingmoved=saveD1bKingmoved;
	c0_wLRockmoved=saveD1wLRockmoved;
	c0_wRRockmoved=saveD1wRRockmoved;
	c0_bLRockmoved=saveD1bLRockmoved;
	c0_bRRockmoved=saveD1bRRockmoved;
	c0_w00=saveD1w00;
	c0_b00=saveD1b00;

	c0_lastmovepawn=saveD1lastmovepawn;
	c0_position=saveD1position;		
	c0_sidemoves=saveD1sidemoves;		
	c0_become=saveD1become;
   }
  }
 return c0_D7poss;
}


/*

*/


//------------------------------ Analyse PGN as text

String c0_PG_gettable()
{
String Event_Name="";
String Event_Site="";
String Event_Date="";
String Round="";
String White="";
String Black="";
String Result="";
String ECO="";
String WhiteElo="";
String BlackElo="";
String Game_Date="";
String Source_Date="";

String AddInfo="";

c0_PGN_header = new String[20];
c0_PGN_head_cnt = 0;

PGN_text= c0_ReplaceAll( PGN_text,"  ", " " );
PGN_text= c0_ReplaceAll( PGN_text, "", "-");

String str2=PGN_text;
int at3;

for(;;)
 {
 int at2=str2.indexOf("[");
 if(at2<0) break;

 int at2_1=str2.indexOf("(");
 int at2_2=str2.indexOf("{");
 if((at2_1>=0 && at2_1<at2) || (at2_2>=0 && at2_2<at2)) break;

 String buf2= substr(str2, at2+1);
 buf2= substr(buf2, 0, buf2.indexOf("]") );
 str2= substr(str2, at2+buf2.length()+2);

 c0_PGN_header[c0_PGN_head_cnt++] = buf2;
 
 buf2= c0_ReplaceAll( buf2,"" + ('"'),"" );
 buf2= c0_ReplaceAll( buf2, "'" ,"" );

 String buf3=buf2.toUpperCase();

 int at9 = buf3.indexOf("SETUP ");
 if(at9>=0 && at9<3) c0_fischer=(substr(buf2,at9+6,1).equals("1"));

 at3 = buf3.indexOf("FEN ");
 if(at3>=0 && at3<3)
 { if( c0_start_FEN.length()==0 )
 	{ c0_start_FEN=substr(buf2,at3+4); c0_set_start_position(""); } }
 else {
 at3 = buf3.indexOf("EVENT ");
 if(at3>=0) Event_Name=substr(buf2,at3+6);
 else {
 at3 = buf3.indexOf("SITE ");
 if(at3>=0) Event_Site=substr(buf2,at3+5);
 else {
 at3 = buf3.indexOf("DATE ");
 if(at3>=0 && at3<3) Game_Date=substr(buf2,at3+5);
 else {
 at3 = buf3.indexOf("ROUND ");
 if(at3>=0) Round=substr(buf2,at3+6);
 else {
 at3 = buf3.indexOf("WHITE ");
 if(at3>=0) White=substr(buf2,at3+6);
 else {
 at3 = buf3.indexOf("BLACK ");
 if(at3>=0) Black=substr(buf2,at3+6);
 else {
 at3 = buf3.indexOf("ECO ");
 if(at3>=0) ECO=substr(buf2,at3+4);
 else {
 at3 = buf3.indexOf("WHITEELO ");
 if(at3>=0) WhiteElo=substr(buf2,at3+9);
 else {
 at3 = buf3.indexOf("BLACKELO ");
 if(at3>=0) BlackElo=substr(buf2,at3+9);
 else {
 at3 = buf3.indexOf("EVENTDATE ");
 if(at3>=0) Event_Date=substr(buf2,at3+10);
 else {
 at3 = buf3.indexOf("SOURCEDATE ");
 if(at3>=0) Source_Date=substr(buf2,at3+11);
 else {
 at3 = buf3.indexOf("RESULT ");
 if(at3>=0) Result=substr(buf2,at3+7);
 else {
 AddInfo+= buf2;
  }}}}}}}}}}}}}
 }

 c0_errflag=c0_PG_parseString(str2);
 if(c0_fischer && c0_fischer_cst.length()>0) c0_fischer_adjustmoved();
 
 at3 = str2.indexOf("*");
 if(at3>=0) Result="not finished";
 at3 = str2.indexOf("1/2");
 if(at3>=0)  Result="1/2-1/2";
 at3 = str2.indexOf("1-0");
 if(at3>=0)  Result="1:0";
 at3 = str2.indexOf("1:0");
 if(at3>=0) Result="1:0";
 at3 = str2.indexOf("0-1");
 if(at3>=0) Result="0:1";
 at3 = str2.indexOf("0:1");
 if(at3>=0) Result="0:1";
 
 String cc = Event_Name + Event_Site + Event_Date +
		Round + White + Black + Result + ECO + WhiteElo +
		BlackElo + Game_Date + Source_Date + AddInfo;
 cc = "";
 
 return c0_PG_2 + cc;
}

//------------------------------ PGN parser on chess moves

String c0_get_moves_from_PGN( String c0_PGN_str)		// Parses PGN moves from string variableown string for chess moves...
{
PGN_text= c0_PGN_str;

c0_PG_gettable();

//if(c0_errflag) alert("There was an error in PGN parsing!");

return c0_PG_1;
}


//------------------------------ PGN parser on chess moves

boolean c0_PG_parseString( String str )		// Parses own string for chess moves...
{
boolean f_error=false;
int gaj=1;
String move="";
String color7="w";
String resultl="[1:0][1-0][1 : 0][1 - 0][0:1][0-1][0 : 1][0 - 1][1/2][1 / 2] [0.5:0.5][1/2:1/2][1/2-1/2][1/2 - 1/2][1/2 : 1/2][*]";

String comment="";
String c_v="0123456789";

c0_PG_1="";
c0_PG_2="";

c0_PG_sh="";

String c0_1save_position=c0_position;
int c0_1save_sidemoves=c0_sidemoves;
boolean c0_1save_wKingmoved=c0_wKingmoved;
boolean c0_1save_bKingmoved=c0_bKingmoved;
boolean c0_1save_wLRockmoved=c0_wLRockmoved;
boolean c0_1save_wRRockmoved=c0_wRRockmoved;
boolean c0_1save_bLRockmoved=c0_bLRockmoved;
boolean c0_1save_bRRockmoved=c0_bRRockmoved;
boolean c0_1save_w00=c0_w00;
boolean c0_1save_b00=c0_b00;
String c0_1save_become=c0_become;
String c0_1save_become_from_engine=c0_become_from_engine;
int c0_1save_lastmovepawn= c0_lastmovepawn;
String c0_1save_moveslist= c0_moveslist;

if( c0_start_FEN.length()>0 ) {  str= ( "{[FEN " + c0_start_FEN + "]} " ) + str; if(c0_sidemoves<0) color7="b";  }
else
{
c0_position = "wpa2,wpb2,wpc2,wpd2,wpe2,wpf2,wpg2,wph2," +
"wRa1,wNb1,wBc1,wQd1,wKe1,wBf1,wNg1,wRh1," +
"bpa7,bpb7,bpc7,bpd7,bpe7,bpf7,bpg7,bph7," +
"bRa8,bNb8,bBc8,bQd8,bKe8,bBf8,bNg8,bRh8,";

c0_moveslist = "";

c0_wKingmoved = false;
c0_bKingmoved = false;
c0_wLRockmoved = false;
c0_wRRockmoved = false;
c0_bLRockmoved = false;
c0_bRRockmoved = false;
c0_w00 = false;
c0_b00 = false;

c0_lastmovepawn = 0;
c0_sidemoves=1;
}

c0_become="";
c0_become_from_engine="";

int st_gaj=1;
int st_atq=str.indexOf('.')-1;

int i,j,k;
char c;

if(st_atq>=0)
 {
  String st_s="";
  for(; st_atq>=0; st_atq--)
	{
	 c=str.charAt(st_atq);
	 if( c_v.indexOf(c) < 0 ) break;
	 st_s="" + c +st_s;		
	}
 if(st_s.length()>0) st_gaj=parseInt(st_s);
 }

for(i=str.length();i>0;i--) if( !substr(str,i-1).equals(" ") ) break;
str=substr(str,0,i);

int atwas=-1;
int atcnt=0;
String reminder;

for(i=0;i<str.length();i++)
 {
 String gS1 = toString(gaj);
 int gS1L = gS1.length();

 if( atwas<i ) { atwas=i; atcnt=0; }
 else if( atwas<=i ) atcnt++;
   // Error corrections...
 if( atcnt==8 || atcnt==12 )
  {
   for( j=i; j>i-50 && j>gS1L; j--)
    {
        // maybe some points missing
     if( substr(str, j-gS1L,gS1L).equals(gS1) )
	  { str=substr(str,0,j)+"."+substr(str,j); atwas++; i=j; break; }
    }
  }
 else if( atcnt>10 )
  {
   int gCd = charCodeAt(str,i);		// try skip character
   if( gCd<48 || (gCd>90 && gCd<97) || gCd>122 )
	str=substr(str,0,i)+"."+substr(str,0,i+1);
  }

 if( atcnt>20 )
 {
	 //alert("Sorry, can't parse this PGN! Errors inside.");
	 f_error=true; break;
 }

 c=str.charAt(i);
 for(;c==' ' && (i+1)<str.length() && str.charAt(i+1)==' '; ) { i++; c=str.charAt(i); }
 if( c==' ' && (i+1)<str.length() && ("{([$").indexOf( str.charAt(i+1) )>=0) { i++; c=str.charAt(i); }

 comment="";

 if(c=='$')
	{
	 String Nag= substr(str, i,3);
	 for( k=0; k<Nag.length(); k++)
		{
		c=Nag.charAt(k);
		if( c_v.indexOf(c) < 0 ) { Nag=substr(Nag,0,k); break; }
		}
	 if(Nag.length()>0)
		{
		String Nag_txt  ="Nag:" + Nag;
		str=substr(str,0,i) +  '{'+ "[" + Nag_txt + "]" +'}' + substr(str,i+Nag.length()+1);
		}
	  c=str.charAt(i);
	  }

 if(c=='{' || c=='(')
  {
   int cc=1;
   char c1= ((c=='{')? '}' : ')' );
   comment=""+c;
   for(i++;i<str.length() && cc>0;i++)
	{
	char c2=str.charAt(i);
	comment+=c2;
	if(c2==c) cc++;
	if(c2==c1) cc--;
	if(i+1==str.length() && cc>0) comment+=c1;
	}
  if(comment.length()>0)
	{
	//Ignore nag codes, variants and annotations
	c0_PG_2+= comment + " ";
	}
  if( color7.equals("b") )
	{
	for( j=i; j<i+15; j++)
		{
		char pj1=str.charAt(j);
		if( ("{([$").indexOf(pj1)>=0 ) break;
		if( substr(str,j,2).equals("..") ) { i=j+1; break; }
		}
	}
  i--;
  }

 else if( c=='.'  || (c==' ' && color7.equals("b") ))
     {
     move="";
     for(;i<str.length() &&
     	( str.charAt(i)==' ' || str.charAt(i)=='.' );i++);
     c=str.charAt(i);
     for(;i<str.length();i++)
	{
    c=str.charAt(i);
	if( c==' '  ) break;
	move+=c;
	}
     if(move.length()>0 && move.indexOf("Z0")<0)
	{
	if(resultl.indexOf(move)>=0 )
		{
		c0_PG_2+="  " +move;
		break;
		}
	else
	 {
	String move2=c0_from_Crafty_standard(move,color7);
	if(move2.length()==0)
	{
		//alert("Can't parse this PGN! move:"+toString(gaj)+"."+color7+" "+ move);
		f_error=true; break;
	}

	int from_horiz4=charCodeAt(substr(move2,0,1),0) - 96;
	int from_vert4=parseInt(substr(move2,1,1));
	int to_horiz4=charCodeAt(substr(move2,2,1),0) - 96;
	int to_vert4=parseInt(substr(move2,3,1));

	String from_move = toString(from_vert4)+toString(from_horiz4);
	String to_move = toString(to_vert4)+toString(to_horiz4);

	if( substr(move2,4,1).equals("["))
		c0_become_from_engine=substr(move2,5,1);
	else c0_become_from_engine="Q";

	if(c0_PGN_short) c0_PG_sh+=c0_shortCode(1,move2);

	if(c0_fischer) c0_fischer_cstl_move(move2);
	else c0_moveto(from_move, to_move);
	c0_sidemoves=-c0_sidemoves;

	c0_PG_1+=move2;

	c0_become_from_engine="";
	c0_become="";

	if( color7.equals("w") )
		{
		c0_PG_2+=toString(st_gaj-1+gaj)+". " +move;
		color7="b"; i--;
		}
	else
		{
		c0_PG_2+=" " +move+" ";
		color7="w"; 
		gaj++;
		}

	if( color7.equals("w") && str.length()-i<10)
		        {
		        reminder = substr(str,i+1);
		        for(;reminder.length()>0 &&
		        	substr(reminder,0,1).equals(" ");)
		        		reminder=substr(reminder,1);
		        if(reminder.length()>0 && resultl.indexOf(reminder)>=0 )
		        	{
		        		c0_PG_2+="  " +reminder;
		        		break;
		        	}
		         }

	 }
	}
     }
 else
    {
     if(str.length()-i<10)
     {
	        reminder = substr(str,i+1);
	        for(;reminder.length()>0 &&
	        	substr(reminder,0,1).equals(" ");)
	        		reminder=substr(reminder,1);
	        if(reminder.length()>0 && resultl.indexOf(reminder)>=0 )
	        	{
	        		c0_PG_2+="  " +reminder;
	        		break;
	        	}
	         }
    }
 }


c0_position=c0_1save_position;
c0_sidemoves=c0_1save_sidemoves;
c0_wKingmoved=c0_1save_wKingmoved;
c0_bKingmoved=c0_1save_bKingmoved;
c0_wLRockmoved=c0_1save_wLRockmoved;
c0_wRRockmoved=c0_1save_wRRockmoved;
c0_bLRockmoved=c0_1save_bLRockmoved;
c0_bRRockmoved=c0_1save_bRRockmoved;
c0_w00=c0_1save_w00;
c0_b00=c0_1save_b00;
c0_become=c0_1save_become;
c0_become_from_engine=c0_1save_become_from_engine;
c0_lastmovepawn=c0_1save_lastmovepawn;
c0_moveslist=c0_1save_moveslist;

return f_error;
}

//------------------------------ just get tag string

String c0_get_tag( String str, String tag )
{
 String ret="";
 String ctg1="["+tag+"]";
 String ctg2="[/"+tag+"]";
 int at1=str.indexOf(ctg1);
 if(at1>=0)
	{
	str=substr(str,at1+ctg1.length());
	at1=str.indexOf(ctg2);
	if(at1>=0) ret=substr(str, 0, at1);
	}
 return ret;
}

//-------------------------------------------------
// Crafty notation (quite a standard)
//-------------------------------------------------
String c0_from_Crafty_standard(String c0_move, String c0_color47)
{
c0_move=c0_ReplaceAll( c0_move, "ep", "" );

String c0_becomes7="";
String c0_ret7=c0_fischer_cst_fCr(c0_move);
if(c0_ret7.length()>0) return c0_ret7;
else if( substr(c0_move,0,5).equals("O-O-O") ||
		substr(c0_move,0,5).equals("0-0-0"))
	{
	if(c0_color47.equals("w"))
		{ 
		  if(c0_position.indexOf("wKc1")<0 && c0_can_be_moved( "15","13",false) ) c0_ret7="e1c1[0]";
	 	}
	else
		{
		  if(c0_position.indexOf("bKc8")<0 && c0_can_be_moved( "85","83",false) ) c0_ret7="e8c8[0]";
	 	}
	}
else if( substr(c0_move,0,3).equals("O-O") ||
		substr(c0_move,0,3).equals("0-0") )
	{
	if(c0_color47.equals("w"))
		{ 
		  if(c0_position.indexOf("wKg1")<0 && c0_can_be_moved( "15","17",false) ) c0_ret7="e1g1[0]";
		}
	else
		{
		  if(c0_position.indexOf("bKg8")<0 && c0_can_be_moved( "85","87",false) ) c0_ret7="e8g8[0]";
		}
	}
else if( ("{ab}{ba}{bc}{cb}{cd}{dc}{de}{ed}{ef}{fe}{fg}{gf}{gh}{hg}").indexOf(substr(c0_move,0,2))>=0 )
  {
       int c0_Z81horiz=charCodeAt(c0_move,0) - 96;
       int c0_Z82horiz=charCodeAt(c0_move,1) - 96;

       for(int c0_i8=0;c0_position.length()>c0_i8; c0_i8+=5)
	{
	String c0_Z8color=substr(c0_position,c0_i8,1);
	String c0_Z8figure=substr(c0_position,c0_i8+1,1);
	int c0_Z8horiz=charCodeAt(substr(c0_position,c0_i8+2,1),0) - 96;
	int c0_Z8vert=parseInt(substr(c0_position,c0_i8+3,1));
	int c0_Z82vert=c0_Z8vert+(c0_color47.equals("w") ? 1 : -1 );
	String c0_Z8from_at72 = toString(c0_Z8vert) + toString(c0_Z8horiz);
	String c0_Z8to_at72 = toString(c0_Z82vert) + toString(c0_Z82horiz);

	if(c0_Z8color.equals(c0_color47) && c0_Z8figure.equals("p")
			&& c0_Z81horiz==c0_Z8horiz )
		{
		if( c0_can_be_moved( c0_Z8from_at72, c0_Z8to_at72,false) )
			{
			c0_ret7=c0_convE777(c0_Z8from_at72)+c0_convE777(c0_Z8to_at72);
			break;
			}
		}
	}

       c0_becomes7=promoIf(c0_move);
       c0_ret7+=c0_becomes7;
   }
else
 {
 int c0_cp7=c0_move.length();

 String c0_figure7=substr(c0_move,0,1);
 if(("NBRQK").indexOf(c0_figure7)>=0) c0_move = substr(c0_move,1);
 else c0_figure7="p";

 c0_becomes7=promoIf(c0_move);
 if(c0_becomes7.length()>0)
	{
	int c0_sh7=c0_move.indexOf("=");
	if(c0_sh7<0) c0_sh7=c0_move.lastIndexOf( substr(c0_becomes7,1,1).toLowerCase() );
        if(c0_sh7>0) c0_move = substr(c0_move, 0, c0_sh7);
	}
 c0_move=c0_ReplaceAll( c0_move, "+", "" );
 c0_move=c0_ReplaceAll( c0_move, "-", "" );
 c0_move=c0_ReplaceAll( c0_move, "x", "" );
 c0_move=c0_ReplaceAll( c0_move, "X", "" );
 c0_move=c0_ReplaceAll( c0_move, "#", "" );
 c0_move=c0_ReplaceAll( c0_move, "!", "" );
 c0_move=c0_ReplaceAll( c0_move, "?", "" );

 c0_cp7=c0_move.length();
 c0_cp7--;	
 String c0_to_at7 = substr(c0_move, c0_cp7-1,2);
 int c0_vert72=parseInt( substr(c0_move,c0_cp7--,1));
 int c0_horiz72= charCodeAt(substr(c0_move, c0_cp7--,1),0) - 96;
 String c0_to_at72 = toString(c0_vert72) + toString(c0_horiz72);
 
 int c0_vert71 = 0;
 if(c0_cp7>=0)
  {
  c0_vert71=parseInt( substr(c0_move,c0_cp7,1));
  if( c0_vert71<1 || c0_vert71>8) c0_vert71=0; else c0_cp7--;
  }
 
 int c0_horiz71=0;
 if(c0_cp7>=0)
  {
  c0_horiz71= charCodeAt(substr(c0_move,c0_cp7--,1),0) - 96;
  if(c0_horiz71<1 || c0_horiz71>8) c0_horiz71=0;
  }

 for(int c0_i4=0;c0_position.length()>c0_i4; c0_i4+=5)
	{
	String c0_Z4color=substr(c0_position,c0_i4,1);
	String c0_Z4figure=substr(c0_position,c0_i4+1,1);
	int c0_Z4horiz=charCodeAt(substr(c0_position,c0_i4+2,1),0) - 96;
	int c0_Z4vert=parseInt(substr(c0_position,c0_i4+3,1));
	String c0_Z4from_at72 = toString(c0_Z4vert) + toString(c0_Z4horiz);
	String c0_Z4from_at7 = substr(c0_position,c0_i4+2,2);

	
	if(c0_Z4color.equals(c0_color47) && c0_figure7.equals(c0_Z4figure))
		{
		 if((c0_vert71==0 || c0_vert71==c0_Z4vert) &&
			(c0_horiz71==0 || c0_horiz71==c0_Z4horiz) )
				{
				if( c0_can_be_moved( c0_Z4from_at72,c0_to_at72,false))
					{
					c0_ret7=c0_Z4from_at7+c0_to_at7+c0_becomes7;
					break;
					}
				}
		}
	}
 }
return c0_ret7;
}

String promoIf(String c0_move)
{
String c0_becomes7="";
int c0_sh7=c0_move.indexOf("=");

if(c0_sh7>0) c0_sh7++;
else
{
if(c0_sh7<0) c0_sh7=c0_move.lastIndexOf("n");
if(c0_sh7<0) c0_sh7=c0_move.lastIndexOf("r");
if(c0_sh7<0) c0_sh7=c0_move.lastIndexOf("q");
// ignore b, causes too much problems, should be =b

if(c0_sh7>0)
 {
  if( ("18ABCDEFGH").indexOf(substr(c0_move,c0_sh7-1,1).toUpperCase() )<0 ) c0_sh7=-1;
 }
else c0_sh7=-1;
}

if(c0_sh7>=0)
	{
	c0_becomes7="["+substr(c0_move,c0_sh7,1).toUpperCase()+"]";
        if( ("[Q][R][B][N]").indexOf(c0_becomes7)<0 ) c0_becomes7="";
	}
return c0_becomes7;
}

//----------------------------------
// Gets  FEN for position
//----------------------------------
String c0_get_FEN()
{
int c0_vert7=8;
int c0_horz7=1;
String c0_fs1="";
int c0_em7=0;

for( c0_vert7=8; c0_vert7>=1;  )
 {
 for( c0_horz7=1; c0_horz7<=8; c0_horz7++ )
	{
	String c0_pos7 = String_fromCharCode(96+c0_horz7)+toString(c0_vert7);
	int c0_at7=c0_position.indexOf( c0_pos7 );
	if( c0_at7>=0 )
		{
		if( c0_em7>0 ) { c0_fs1+=toString(c0_em7); c0_em7=0; }
		String c0_ch7= substr( c0_position, c0_at7-1, 1 );
		String c0_color7= substr( c0_position, c0_at7-2, 1 );
		if( c0_color7.equals("w") ) c0_fs1+=c0_ch7.toUpperCase();
		else c0_fs1+=c0_ch7.toLowerCase();
		}
	else c0_em7++;
	}
 if( c0_em7>0 ) { c0_fs1+=toString(c0_em7); c0_em7=0; }
 c0_vert7--;
 if(c0_vert7<1) break;
 c0_fs1+="/";
 }

c0_fs1+=" " + (( c0_sidemoves>0)? "w" : "b" ) + " ";

if(  (c0_w00 || c0_wKingmoved || (c0_wLRockmoved && c0_wRRockmoved))  && 
     (c0_b00 || c0_bKingmoved || (c0_bLRockmoved && c0_bRRockmoved)) ) c0_fs1+="- ";
else
 {
  if( !(c0_w00 || c0_wKingmoved) && !c0_wLRockmoved ) c0_fs1+="Q";
  if( !(c0_w00 || c0_wKingmoved) && !c0_wRRockmoved ) c0_fs1+="K";
  if( !(c0_b00 || c0_bKingmoved) && !c0_bLRockmoved ) c0_fs1+="q";
  if( !(c0_b00 || c0_bKingmoved) && !c0_bRRockmoved ) c0_fs1+="k";
  c0_fs1+=" ";
 }

 String c0_enpass7="-";

 if(c0_lastmovepawn>0)
	{
	String c0_lmove7= substr( c0_moveslist, c0_moveslist.length()-4, 4 );
	c0_vert7 = charCodeAt(c0_lmove7,1);

	if( substr(c0_lmove7,0,1).equals( substr(c0_lmove7,2,1)) &&
		( charCodeAt(c0_lmove7,0)-96==c0_lastmovepawn) &&
		 (( substr(c0_lmove7,1,1).equals("7") &&
				 substr(c0_lmove7,3,1).equals("5") ) ||
		  ( substr(c0_lmove7,1,1).equals("2") &&
				  substr(c0_lmove7,3,1).equals("4") )) )
	{
	 int c0_at7=c0_position.indexOf( substr(c0_lmove7,2,2) );
	 if( c0_at7>=0 && substr( c0_position, c0_at7-1,1 ).equals("p") )
		{
		c0_enpass7= substr(c0_lmove7,0,1);
		if( substr(c0_lmove7,1,1).equals("7") ) c0_enpass7+="6";
		else c0_enpass7+="3";
		}
	}
	}
c0_fs1+=c0_enpass7 + " ";

c0_fs1+="0 ";		// position repeating moves....

int c0_mcount7=2;
for( int c0_i7=0; c0_i7<c0_moveslist.length();  )
	{
	c0_i7+=4;
	if( substr(c0_moveslist,c0_i7,1).equals("[")) c0_i7+=3;
	c0_mcount7+=1;
	}
c0_fs1+= toString((int)(c0_mcount7/2)) + " ";

return c0_fs1;
}

//----------------------------------
// Sets position using FEN
//----------------------------------
void c0_set_FEN( String c0_fen_str )
{
int c0_vert7=8;
int c0_horz7=1;

String c0_fs1="";
String c0_fs2="";

int c0_i7, c0_j7;
String c0_ch7;

for( c0_i7=0; c0_i7<c0_fen_str.length(); c0_i7++)
{
c0_ch7=substr(c0_fen_str,c0_i7,1);
if( c0_ch7.equals(" ") ) break;
int c0_pusto=parseInt(c0_ch7);
if(c0_pusto>=1 && c0_pusto<=8)  { for( c0_j7=1; c0_j7<=c0_pusto; c0_j7++) c0_fs1+="."; }
else c0_fs1+=c0_ch7;
}
c0_fs1+= (" " + substr(c0_fen_str,c0_i7));

for( c0_i7=0; c0_i7<c0_fs1.length(); c0_i7++)
{
c0_ch7=substr(c0_fs1,c0_i7,1);
if( c0_ch7.equals(" ") ) break;

String c0_pos7 = String_fromCharCode(96+c0_horz7)+toString(c0_vert7);
String c0_color7=" ";
if(("pnbrqk").indexOf(c0_ch7)>=0) c0_color7="b";
if(("PNBRQK").indexOf(c0_ch7)>=0) c0_color7="w";
if(!c0_color7.equals(" "))
	 {
	 if(("pP").indexOf(c0_ch7)>=0) c0_ch7="p";
	 else c0_ch7=c0_ch7.toUpperCase();

	 c0_fs2+=(c0_color7 + c0_ch7 + c0_pos7 + ";");
	 }
if(c0_ch7.equals("/")) { if(c0_horz7>1) {c0_vert7--; c0_horz7=1;} }
else { c0_horz7++; if(c0_horz7>8) { c0_horz7=1; c0_vert7--; } }

if(c0_vert7<1) break;
}

for(; c0_i7<c0_fs1.length(); c0_i7++)
	if( substr(c0_fs1,c0_i7,1).equals(" ") ) break;
for(; c0_i7<c0_fs1.length(); c0_i7++)
	if( !substr(c0_fs1,c0_i7,1).equals(" ") ) break;

// which moves
int c0_side7move=1;
if(c0_i7<c0_fs1.length() && substr(c0_fs1,c0_i7,1).equals("b"))
		c0_side7move=-1;

for(; c0_i7<c0_fs1.length(); c0_i7++)
	if( substr(c0_fs1,c0_i7,1).equals(" ") ) break;
for(; c0_i7<c0_fs1.length(); c0_i7++)
	if( !substr(c0_fs1,c0_i7,1).equals(" ") ) break;

// castlings

boolean c0_wK7=false;
boolean c0_wRL7=false;
boolean c0_wRR7=false;
boolean c0_wcastl7=false;
boolean c0_bK7=false;
boolean c0_bRL7=false;
boolean c0_bRR7=false;
boolean c0_bcastl7=false;

String c0_q7="-";
if(c0_i7<c0_fs1.length())
{
 c0_q7=substr(c0_fs1,c0_i7);
 int c0_at7=c0_q7.indexOf(" ");
 if( c0_at7>=0 ) c0_q7=substr(c0_q7,0,c0_at7);
}
if( c0_q7.indexOf("K")<0 ) c0_wRR7=true;
if( c0_q7.indexOf("Q")<0 ) c0_wRL7=true;

if( c0_q7.indexOf("k")<0 ) c0_bRR7=true;
if( c0_q7.indexOf("q")<0 ) c0_bRL7=true;

if( c0_q7.indexOf("-")>=0 ) { c0_wK7=true;  c0_bK7=true; }

c0_fisch_castl_save(c0_q7,c0_fs2);

for(; c0_i7<c0_fs1.length(); c0_i7++)
	if( substr(c0_fs1,c0_i7,1).equals(" ") ) break;
for(; c0_i7<c0_fs1.length(); c0_i7++)
	if( !substr(c0_fs1,c0_i7,1).equals(" ") ) break;

// en passant

c0_q7="-";
if(c0_i7<c0_fs1.length()) c0_q7=substr(c0_fs1,c0_i7,1);

int c0_enpass7=0;
if( c0_q7.indexOf("-")<0 ) c0_enpass7=charCodeAt(c0_q7,0)-96;

for(; c0_i7<c0_fs1.length(); c0_i7++)
	if( substr(c0_fs1,c0_i7,1).equals(" ") ) break;
for(; c0_i7<c0_fs1.length(); c0_i7++)
	if( !substr(c0_fs1,c0_i7,1).equals(" ") ) break;

// remaining information is omitted

c0_set_board_situation( c0_fs2, c0_wK7, c0_wRL7, c0_wRR7, c0_wcastl7, c0_bK7, c0_bRL7, c0_bRR7, c0_bcastl7, c0_enpass7, c0_moveslist, c0_side7move );

}

//----------------------------------
// PGN parser on chess moves
//----------------------------------
String c0_get_from_PGN(String c0_PGN_str)		// To get moveslist and header from PGN string...
{
String save_PGN_text=PGN_text;

PGN_text= c0_PGN_str;

c0_PG_gettable();

PGN_text=save_PGN_text;

return c0_PG_1;
}

//----------------------------------
// PGN parser on chess moves
//----------------------------------
String c0_put_to_PGN(String c0_moves_str)		// To write moveslist to PGN string...
{

if( c0_moves_str.length()==0 ) c0_moves_str=c0_moveslist;

c0_errflag=false;
String c0_1save_position=c0_position;
int c0_1save_sidemoves=c0_sidemoves;
boolean c0_1save_wKingmoved=c0_wKingmoved;
boolean c0_1save_bKingmoved=c0_bKingmoved;
boolean c0_1save_wLRockmoved=c0_wLRockmoved;
boolean c0_1save_wRRockmoved=c0_wRRockmoved;
boolean c0_1save_bLRockmoved=c0_bLRockmoved;
boolean c0_1save_bRRockmoved=c0_bRRockmoved;
boolean c0_1save_w00=c0_w00;
boolean c0_1save_b00=c0_b00;
String c0_1save_become=c0_become;
String c0_1save_become_from_engine=c0_become_from_engine;
int c0_1save_lastmovepawn= c0_lastmovepawn;
String c0_1save_moveslist= c0_moveslist;

if( c0_start_FEN.length()>0 )
	{ c0_set_FEN( c0_start_FEN ); c0_fischer_adjustmoved(); }
else
{
c0_position = "wpa2,wpb2,wpc2,wpd2,wpe2,wpf2,wpg2,wph2," +
"wRa1,wNb1,wBc1,wQd1,wKe1,wBf1,wNg1,wRh1," +
"bpa7,bpb7,bpc7,bpd7,bpe7,bpf7,bpg7,bph7," +
"bRa8,bNb8,bBc8,bQd8,bKe8,bBf8,bNg8,bRh8,";

c0_moveslist = "";

c0_wKingmoved = false;
c0_bKingmoved = false;
c0_wLRockmoved = false;
c0_wRRockmoved = false;
c0_bLRockmoved = false;
c0_bRRockmoved = false;
c0_w00 = false;
c0_b00 = false;

c0_lastmovepawn = 0;
c0_sidemoves=1;
}

c0_become="";
c0_become_from_engine="";

String c0_PGN_ret="";

String Result="";

String CR=( String_fromCharCode(13) +  String_fromCharCode(10) );
String peka = "" + ('"');
for(int c0_i7=0; c0_i7<c0_PGN_head_cnt; c0_i7++)
	{
	String c0_q9=c0_PGN_header[c0_i7].toUpperCase();
	int c0_at_q8=c0_q9.indexOf( "FEN " );
	if(c0_at_q8<0 && c0_fischer) c0_at_q8=c0_q9.indexOf( "SETUP " );
	if( c0_at_q8<0 || c0_at_q8>3 )
	{
	c0_PGN_ret += ( '[' + c0_PGN_header[c0_i7] + ']' + CR );
	int c0_at_q9=c0_q9.indexOf( "RESULT " );
	if( c0_at_q9>=0 )
		{
		Result=substr( c0_PGN_header[c0_i7], c0_at_q9 + 7 );
		Result=c0_ReplaceAll( Result, peka, "" );
		Result=c0_ReplaceAll( Result, "'", "" );
		Result=c0_ReplaceAll( Result, " ", "" );
 		}
	}
	}
if( c0_start_FEN.length()>0 )
	{
	if(c0_fischer) c0_PGN_ret += "[SetUp "+ peka + "1" + peka + "]" + CR;
	c0_PGN_ret += "[FEN " + peka + c0_start_FEN + peka + "]" + CR;
	}
if( c0_PGN_ret.length()>0 ) c0_PGN_ret += CR;

int c07_gaj=0;
String c07_col="b";

for( int c0_i7=0; c0_i7< c0_moves_str.length(); )
 {
if(c07_col.equals("w")) c07_col="b";
else { c07_col="w"; c07_gaj++; }


 String c0_move8 = substr( c0_moves_str, c0_i7, 4 );
 c0_i7+=4;
 if( c0_i7< c0_moves_str.length() &&
		 substr( c0_moves_str, c0_i7, 1 ).equals("[") )
	{
	c0_move8+=substr( c0_moves_str, c0_i7, 3 );
	c0_i7+=3;
	}

 String c0_move9=c0_to_Crafty_standard( c0_move8, c07_col );
 if( c0_move9.length()>0 )
	{
	if( c07_col.equals("w") ) c0_PGN_ret+=toString(c07_gaj) + ". ";
	c0_PGN_ret+=c0_move9 + " ";
	}
else { c0_errflag=true; break; }
}

if(!c0_errflag) c0_PGN_ret+=" " +Result;

c0_position=c0_1save_position;
c0_sidemoves=c0_1save_sidemoves;
c0_wKingmoved=c0_1save_wKingmoved;
c0_bKingmoved=c0_1save_bKingmoved;
c0_wLRockmoved=c0_1save_wLRockmoved;
c0_wRRockmoved=c0_1save_wRRockmoved;
c0_bLRockmoved=c0_1save_bLRockmoved;
c0_bRRockmoved=c0_1save_bRRockmoved;
c0_w00=c0_1save_w00;
c0_b00=c0_1save_b00;
c0_become=c0_1save_become;
c0_become_from_engine=c0_1save_become_from_engine;
c0_lastmovepawn=c0_1save_lastmovepawn;
c0_moveslist=c0_1save_moveslist;

//if(c0_errflag) alert("Can't parse " + c07_gaj.toString() + c07_col + ":" + c0_move8);

if( c0_start_FEN.length()>0 )
	{
	c0_set_board_situation( c0_position, c0_wKingmoved, c0_wLRockmoved, c0_wRRockmoved, c0_w00, c0_bKingmoved, c0_bLRockmoved, c0_bRRockmoved, c0_b00, c0_lastmovepawn, c0_moveslist, c0_sidemoves );
	}

return c0_PGN_ret;
}

//-------------------------------------------------
// Crafty notation (quite a standard)
//-------------------------------------------------
String c0_to_Crafty_standard(String c0_move, String c0_color47)
{
 String c0_ret9=c0_fischer_cst_tCr(c0_move);
 if(c0_ret9.length()>0)
	{
	c0_fischer_cstl_move(c0_move);
	c0_sidemoves=-c0_sidemoves;
	return c0_ret9;
	}

 String c0_pos9=c0_position;
 int c0_at9=c0_position.indexOf( substr(c0_move,0,2) );

 c0_become_from_engine="";
 if( c0_move.length()>4 ) c0_become_from_engine=substr(c0_move,5,1);

 if(c0_at9>=0 )
  {
  String c0_9figure=substr(c0_position, c0_at9-1,1 );
  String c0_9color=substr(c0_position, c0_at9-2,1 );
  if( c0_9color.equals(c0_color47) )
   {
    int c0_Z4horiz=charCodeAt(substr(c0_move,0,1),0) - 96;
    int c0_Z4vert=parseInt(substr(c0_move,1,1));
    String c0_Z4from_at72 = toString(c0_Z4vert) + toString(c0_Z4horiz);
    int c0_Z5horiz= charCodeAt(substr(c0_move,2,1),0) - 96;
    int c0_Z5vert=parseInt(substr(c0_move,3,1));
    String c0_Z5to_at72 = toString(c0_Z5vert) + toString(c0_Z5horiz);

    if( c0_become_from_engine.length()==0 &&
    		c0_9figure.equals("p") && (c0_Z5vert==8 || c0_Z5vert==1) )
    		c0_become_from_engine="Q";

    if( c0_can_be_moved( c0_Z4from_at72,c0_Z5to_at72,false ) )
      {
        if( !c0_9figure.equals("p") )
	{
	int c0_figc9=0;
	int c0_i4;
	for(c0_i4=0;c0_position.length()>c0_i4; c0_i4+=5)
	{
	String c0_Q4color=substr(c0_position,c0_i4,1);
	String c0_Q4figure=substr(c0_position,c0_i4+1,1);
	if(c0_Q4color.equals(c0_color47) &&
			c0_9figure.equals(c0_Q4figure)) c0_figc9++;
	}

	for(c0_i4=0;c0_position.length()>c0_i4; c0_i4+=5)
	{
	String c0_Q4color=substr(c0_position,c0_i4,1);
	String c0_Q4figure=substr(c0_position,c0_i4+1,1);
	int c0_Q4horiz=charCodeAt(substr(c0_position,c0_i4+2,1),0) - 96;
	int c0_Q4vert=parseInt(substr(c0_position,c0_i4+3,1));
	String c0_Q4from_at72 = toString(c0_Q4vert) + toString(c0_Q4horiz);
	String c0_Q4from_at7 = substr(c0_position,c0_i4+2,2);

	if(c0_Q4color.equals(c0_color47) &&
			c0_9figure.equals(c0_Q4figure) &&
				!c0_Q4from_at7.equals( substr(c0_move,0,2) ))
		{
		if( c0_can_be_moved( c0_Q4from_at72, c0_Z5to_at72,false))
			{
			if( c0_figc9 < 3 && c0_Z4horiz!=c0_Q4horiz )
				{
				c0_ret9 += substr(c0_move,0,1);
				}
			else
				{
				c0_ret9 += substr(c0_move,0,2) + "-" ;
				}
			break;
			}
		}
	}
	}
	c0_moveto( c0_Z4from_at72,c0_Z5to_at72 );
	c0_sidemoves=-c0_sidemoves;
	
	boolean KingB = c0_9figure.equals("K");
	boolean wB = c0_9color.equals("w");
	boolean bB = c0_9color.equals("b");
	String mv4 = substr(c0_move,0,4);
	if( KingB && wB && mv4.equals("e1g1") ) c0_ret9="O-O";
	else if( KingB && bB && mv4.equals("e8g8") ) c0_ret9="O-O";
	else if( KingB && wB && mv4.equals("e1c1") ) c0_ret9="O-O-O";
	else if( KingB && bB && mv4.equals("e8c8") ) c0_ret9="O-O-O";
		else
		{
	  	c0_ret9 = (c0_9figure.equals("p") ? "" : c0_9figure) + c0_ret9; 

		if( c0_pos9.length() > c0_position.length() )
			{
			 if( substr( c0_ret9, c0_ret9.length()-1,1).equals("-") )
				 	c0_ret9=substr(c0_ret9,0,c0_ret9.length()-1);
			 c0_ret9 += "x";
			}

		if( substr(c0_ret9,0,1).equals("x") )
			c0_ret9= substr(c0_move,0,1) + c0_ret9;

		c0_ret9 += substr(c0_move,2,2); 
		if( c0_become_from_engine.length()>0 )
				c0_ret9+= "=" + c0_become_from_engine;
		String oppK = (c0_color47.equals("w") ? "b" : "w" );
		if( c0_is_mate_to_king( oppK, true ) ) c0_ret9+= "#";
		else if( c0_is_check_to_king( oppK ) ) c0_ret9+= "+";
		}
       }
   }
  }
return c0_ret9;
}

// Fischerrandom support functions...
//------- Get castling settings into variable...
void c0_fisch_castl_save(String c0_fen_c, String c0_fen_pos)
{
c0_fischer_cst="";
int atW=c0_fen_pos.indexOf("wK");
int atB=c0_fen_pos.indexOf("bK");
if(atW>=0 && atB>=0)
	{
	c0_fischer_cst+=("{wK}"+ substr(c0_fen_pos,atW,5)+
			"{bK}"+ substr(c0_fen_pos,atB,5));
	int c0_q8;
	for( c0_q8=1; c0_q8<=16; c0_q8++)
		{
		String c0_ch=String_fromCharCode(c0_q8<9 ? 96+c0_q8 : 64+c0_q8-8);
		String c0_cl=(c0_q8<9 ? "b" : "w");
		String c0_vt=(c0_q8<9 ? "8" : "1");
		String c0_hz=String_fromCharCode(96+c0_q8-(c0_q8<9?0:8));
		String c0_rook=c0_cl+"R"+c0_hz+c0_vt+";";
		if(c0_fen_c.indexOf(c0_ch)>=0 && c0_fen_pos.indexOf(c0_rook)>=0)
		 {
		 if(c0_q8<9)
		  {
		  if( c0_fen_pos.charAt(atB+2)>c0_hz.charAt(0) ) c0_fischer_cst+="{bLR}";
		  else c0_fischer_cst+="{bRR}";
		  }
		  else
		  {
		  if( c0_fen_pos.charAt(atW+2)>c0_hz.charAt(0) ) c0_fischer_cst+="{wLR}";
		  else c0_fischer_cst+="{wRR}";
		  }
		 c0_fischer_cst+=c0_rook;
		 }
		}
	for( c0_q8=0; c0_q8<c0_fen_pos.length(); c0_q8+=5)
		{
		String c0_pc= substr(c0_fen_pos,c0_q8+1,1);
		if(c0_pc.equals("R"))
		{
		String c0_cl=substr(c0_fen_pos,c0_q8,1);
		String c0_hz=substr(c0_fen_pos,c0_q8+2,1);
		String c0_rook=substr(c0_fen_pos,c0_q8,5);

		if(c0_cl.equals("w"))
		{
		if(c0_fischer_cst.indexOf("{wLR}")<0 && c0_fen_c.indexOf("Q")>=0 &&
			c0_fen_pos.charAt(atW+2)>c0_hz.charAt(0)) c0_fischer_cst+="{wLR}"+c0_rook;
		else if(c0_fischer_cst.indexOf("{wRR}")<0 && c0_fen_c.indexOf("K")>=0 &&
			c0_fen_pos.charAt(atW+2)<c0_hz.charAt(0)) c0_fischer_cst+="{wRR}"+c0_rook;
		}
		else
		{
		if(c0_fischer_cst.indexOf("{bLR}")<0 && c0_fen_c.indexOf("q")>=0 &&
			c0_fen_pos.charAt(atB+2)>c0_hz.charAt(0)) c0_fischer_cst+="{bLR}"+c0_rook;
		else if(c0_fischer_cst.indexOf("{bRR}")<0 && c0_fen_c.indexOf("k")>=0 &&
				c0_fen_pos.charAt(atB+2)<c0_hz.charAt(0)) c0_fischer_cst+="{bRR}"+c0_rook;
		}
		}
		}
	}
}

//------- Adjust main variables after position is set...
void c0_fischer_adjustmoved()
{
if(c0_fischer_cst.indexOf("{bLR}")>=0 && c0_fischer_cst.indexOf("{bK}")>=0)
	{ c0_bKingmoved = false; c0_bLRockmoved = false; c0_b00 = false; }
if(c0_fischer_cst.indexOf("{bRR}")>=0 && c0_fischer_cst.indexOf("{bK}")>=0)
	{ c0_bKingmoved = false; c0_bRRockmoved = false; c0_b00 = false; }
if(c0_fischer_cst.indexOf("{wLR}")>=0 && c0_fischer_cst.indexOf("{wK}")>=0)
	{ c0_wKingmoved = false; c0_wLRockmoved = false; c0_w00 = false; }
if(c0_fischer_cst.indexOf("{wRR}")>=0 && c0_fischer_cst.indexOf("{wK}")>=0)
	{ c0_wKingmoved = false; c0_wRRockmoved = false; c0_w00 = false; }
}

//------- Does fischer movings for castling...
void c0_fischer_cstl_move(String c0_moving)
{
String c0_king="";
String c0_rook="";
String c0_king2="";
String c0_rook2="";

if(substr(c0_moving,0,4).equals("00**"))
	{
	if(c0_sidemoves>0)
		{
		c0_king=substr(c0_fischer_cst, c0_fischer_cst.indexOf("{wK}")+4,4 );
		c0_rook=substr(c0_fischer_cst, c0_fischer_cst.indexOf("{wRR}")+5,4 );
		c0_king2="wKg1"; c0_rook2="wRf1";
		c0_wKingmoved=true;c0_wLRockmoved=true;c0_wRRockmoved=true;c0_w00=true;
		}
	else
		{
		c0_king=substr(c0_fischer_cst, c0_fischer_cst.indexOf("{bK}")+4,4 );
		c0_rook=substr(c0_fischer_cst, c0_fischer_cst.indexOf("{bRR}")+5,4 );	
		c0_king2="bKg8"; c0_rook2="bRf8";
		c0_bKingmoved=true;c0_bLRockmoved=true;c0_bRRockmoved=true;c0_b00=true;
		}
	}
else if(substr(c0_moving,0,4).equals("000*"))
	{
	if(c0_sidemoves>0)
		{
		c0_king=substr(c0_fischer_cst, c0_fischer_cst.indexOf("{wK}")+4,4 );
		c0_rook=substr(c0_fischer_cst, c0_fischer_cst.indexOf("{wLR}")+5,4 );
		c0_king2="wKc1"; c0_rook2="wRd1";
		c0_wKingmoved=true;c0_wLRockmoved=true;c0_wRRockmoved=true;c0_w00=true;
		}
	else
		{
		c0_king=substr(c0_fischer_cst, c0_fischer_cst.indexOf("{bK}")+4,4 );
		c0_rook=substr(c0_fischer_cst, c0_fischer_cst.indexOf("{bLR}")+5,4 );
		c0_king2="bKc8"; c0_rook2="bRd8";
		c0_bKingmoved=true;c0_bLRockmoved=true;c0_bRRockmoved=true;c0_b00=true;
		}
	}
else
	{
	String c0_from_at=substr(c0_moving,0,2);
	String c0_to_at=substr(c0_moving,2,2);
	c0_moveto(c0_convH888(c0_from_at), c0_convH888(c0_to_at));
	}

if(c0_king.length()>0 && c0_rook.length()>0)
	{
		if(!(c0_king==c0_king2)) c0_position=c0_ReplaceAll(c0_position,c0_king,c0_king2);
		if(!(c0_rook==c0_rook2)) c0_position=c0_ReplaceAll(c0_position,c0_rook,c0_rook2);
	}
}

//------- Saves fischer movings for castling from Crafty standard...
String c0_fischer_cst_fCr(String c0_move)
{
String c0_ret8="";
if(c0_fischer)
{
String c0_move95 = substr(c0_move,0,5);
String c0_move93 = substr(c0_move,0,3);
if(c0_move95.equals("O-O-O") || c0_move95.equals("0-0-0")) c0_ret8="000*";
else if(c0_move93.equals("O-O") || c0_move93.equals("0-0")) c0_ret8="00**";
}
return c0_ret8;
}

//------- Saves to Crafty standard...
String c0_fischer_cst_tCr(String c0_move)
{
String c0_ret8="";
if(c0_fischer)
{
String c0_move94 = substr(c0_move,0,4);	
if(c0_move94.equals("000*")) c0_ret8="0-0-0";
else if(c0_move94.equals("00**")) c0_ret8="0-0";
}
return c0_ret8;
}

//--------------------------------------------------------------
// Short notation encoding (internal for this libraries only)
//--------------------------------------------------------------

//------- Short notation move->code or code->move...
String c0_shortCode(int ch7, String P1)
{
 String cDret="";
 String cDp0="abcdefghijklmnopqrstuvxyz0123456789ABCDEFGHIJKLMNOPQRSTUVXYZ";
 String cDp=c0_get_next_moves();
 String cDp1="";
 for(int c77=0;c77<cDp.length();c77+=5)
 {
  String c7move=substr(cDp,c77,4);
  if( ( c0_position.charAt( c0_position.indexOf( substr(c7move,0,2))-1 )=='p' ) &&
	 (("18").indexOf( c7move.charAt(3) )>=0) )
		{
		cDp1+=c7move+"[Q]"+';'+c7move+"[R]"+';'+c7move+"[B]"+';'+c7move+"[N]"+';';
		}
  else cDp1+=c7move+"   ;";
  if(cDp.charAt(c77+4)=='[') c77+=3;
 }

 if(ch7==1)
	{
	String cDcmp=P1;
	if((cDcmp.length()>4) &&
			( substr(cDcmp,4,3).equals("[0]"))) cDcmp=substr(cDcmp,0,4);
	cDret=substr(cDp0,(cDp1.indexOf(cDcmp)/8),1);
	}
 else if(ch7==-1)
	{
	String cDmove= substr(cDp1, (cDp0.indexOf(P1))*8,7);
	c0_become_from_engine=substr(cDmove,5,1);
	if(c0_become_from_engine.equals(" ")) c0_become_from_engine="Q";
	c0_become=c0_become_from_engine;
	if( ("Q ").indexOf( cDmove.charAt(5) )>=0 ) cDmove=substr(cDmove,0,4);
	cDret=cDmove;
	}
 return cDret;
}

//------- Converts short notation to moveslist...
void c0_short2list()
{
c0_errflag=false;
String c0_1save_position=c0_position;
int c0_1save_sidemoves=c0_sidemoves;
boolean c0_1save_wKingmoved=c0_wKingmoved;
boolean c0_1save_bKingmoved=c0_bKingmoved;
boolean c0_1save_wLRockmoved=c0_wLRockmoved;
boolean c0_1save_wRRockmoved=c0_wRRockmoved;
boolean c0_1save_bLRockmoved=c0_bLRockmoved;
boolean c0_1save_bRRockmoved=c0_bRRockmoved;
boolean c0_1save_w00=c0_w00;
boolean c0_1save_b00=c0_b00;
String c0_1save_become=c0_become;
String c0_1save_become_from_engine=c0_become_from_engine;
int c0_1save_lastmovepawn= c0_lastmovepawn;

c0_moveslist = "";		// will contain moves on return...

if( c0_start_FEN.length()>0 )
	{ c0_set_FEN( c0_start_FEN ); c0_fischer_adjustmoved(); }
else
{
c0_position = "wpa2,wpb2,wpc2,wpd2,wpe2,wpf2,wpg2,wph2," +
"wRa1,wNb1,wBc1,wQd1,wKe1,wBf1,wNg1,wRh1," +
"bpa7,bpb7,bpc7,bpd7,bpe7,bpf7,bpg7,bph7," +
"bRa8,bNb8,bBc8,bQd8,bKe8,bBf8,bNg8,bRh8,";

c0_wKingmoved = false;
c0_bKingmoved = false;
c0_wLRockmoved = false;
c0_wRRockmoved = false;
c0_bLRockmoved = false;
c0_bRRockmoved = false;
c0_w00 = false;
c0_b00 = false;

c0_lastmovepawn = 0;
c0_sidemoves=1;
}

c0_become="";
c0_become_from_engine="";

for( int c0_i7=0; c0_i7< c0_PG_sh.length(); c0_i7++)
 {
 String c0_move8=c0_shortCode(-1, substr(c0_PG_sh,c0_i7,1));
 if(c0_move8.length()<4) { c0_errflag=true; break; }

 if(c0_fischer) c0_fischer_cstl_move( substr(c0_move8,0,4));
 else c0_moveto(c0_convH888(substr(c0_move8,0,2)),c0_convH888(substr(c0_move8,2,2)));
 c0_sidemoves=-c0_sidemoves;
}

c0_position=c0_1save_position;
c0_sidemoves=c0_1save_sidemoves;
c0_wKingmoved=c0_1save_wKingmoved;
c0_bKingmoved=c0_1save_bKingmoved;
c0_wLRockmoved=c0_1save_wLRockmoved;
c0_wRRockmoved=c0_1save_wRRockmoved;
c0_bLRockmoved=c0_1save_bLRockmoved;
c0_bRRockmoved=c0_1save_bRRockmoved;
c0_w00=c0_1save_w00;
c0_b00=c0_1save_b00;
c0_become=c0_1save_become;
c0_become_from_engine=c0_1save_become_from_engine;
c0_lastmovepawn=c0_1save_lastmovepawn;

//if(c0_errflag) alert("Can't parse encoded chess game ");

if( c0_start_FEN.length()>0 )
	{
	c0_set_board_situation( c0_position, c0_wKingmoved, c0_wLRockmoved, c0_wRRockmoved, c0_w00, c0_bKingmoved, c0_bLRockmoved, c0_bRRockmoved, c0_b00, c0_lastmovepawn, c0_moveslist, c0_sidemoves );
	}
}

void printout( String s)
{ System.out.println(s);}

//-------------- Samples to test
void SAMPLES ()
{
	
    printout("============================================");
    printout("===== Routine a_SAMPLES of chess logic =====");
    printout("============================================");
 

	c0_set_start_position("");		   // Set the initial position... 
	
    // 1. Test for basic chess functions (ok)
    printout( "Setting up the starting position" );
    printout( c0_position );
    printout( "FEN function : " + c0_get_FEN() );

	// Make a first move e4...
	c0_move_to("e2","e4");
	printout( "Position after e4:");
    printout( c0_position );
    
	// Show the last move made...
	printout ( "Last move:" + c0_D_last_move_was() );

    // switch sides
    c0_sidemoves = -c0_sidemoves; 
    printout ( "All movements till now:" + c0_moveslist );
    
    // To see possible movements...
	printout( "Now possible moves:");
    printout( c0_get_next_moves() );
    
    // And take it back...
	c0_take_back();
	printout ( "Position after takeback" );
    printout( c0_position );
    c0_sidemoves = -c0_sidemoves;
  
	//Other functions:
	//Is e2-e4 a legal move in current position...
	printout( "Can move a2-a4? ");
    printout( c0_D_can_be_moved("a2","a4") ? "yes" : "no" );
    
	//Is there stalemate to the white king right now? ("b"/"w"- the parameter)
	printout( "White king in stalemate? ");
    printout( c0_D_is_stalemate_to_king("w") ? "yes" : "no" );
    
	//Is there check to the white king right now? 
	printout( "Check to white king?");
    printout( c0_D_is_check_to_king("w") ? "yes" : "no" );
    
	//Is there checkmate to the white king right now? 
	printout( "Is checkmate to white king?");
    printout( c0_D_is_mate_to_king("w") ? "yes" : "no" );
	
	// What a piece on the square g7?
	printout( "Piece on g7:" + c0_D_what_at("g7") );
    
	// Is the square g6 empty? (no piece on it)
	printout( "Is empty square g6? ");
	printout( c0_D_is_empty("g6") ? "yes" : "no" );
    
    // FEN position setup test
    //c0_start_FEN="7k/Q7/2P2K2/8/8/8/8/8 w - - 0 70";
    //c0_set_start_position("");
    c0_set_FEN ("7k/Q7/2P2K2/8/8/8/8/8 w - - 0 70");
    
    
    printout( "Position after setup FEN=7k/Q7/2P2K2/8/8/8/8/8 w - - 0 70");
    printout( c0_position );
    printout( "Move Qa7-g7x");
    c0_move_to("a7","g7");
	//Is there checkmate to the black king right now? 
	printout( "Is checkmate to black king?");
    printout( c0_D_is_mate_to_king("b") ? "yes" : "no" );
    
    c0_start_FEN="";
    c0_set_start_position("");
    
    // 2.PGN functions test (ok):
    printout("PGN -> moves");
	String PGN0="1.d4 d5 2.c4 e6 {comment goes here} 3.Nf3 Nf6 4.g3 Be7 (4.h4 or variant) 5.Bg2 0-0 6.0-0 dxc4 7.Qc2 a6 8.Qxc4 b5 9.Qc2 Bb7 10.Bd2 Be4 11.Qc1 Bb7 12.Qc2 Ra7 13.Rc1 Be4 14.Qb3 Bd5 15.Qe3 Nbd7 16.Ba5 Bd6 17.Nc3 Bb7 18.Ng5 Bxg2 19.Kxg2 Qa8+ 20.Qf3 Qxf3+ 21.Kxf3 e5 22.e3 Be7 23.Ne2 Re8 24.Kg2 Nd5 25.Nf3 Bd6 26.dxe5 Nxe5 27.Nxe5 Rxe5 28.Nd4 Ra8 29.Nc6 Re6 30.Rc2 Nb6 31.b3 Kf8 32.Rd1 Ke8 33.Nd4 Rf6 34.e4 Rg6 35.e5 Be7 36.Rxc7 Nd5 37.Rb7 Bd8 38.Nf5 Nf4+ 39.Kf3 Bxa5 40.gxf4 Bb4 41.Rdd7 Rc8 42.Rxf7 Rc3+ 43.Ke4 1-0";
	String mlist0 = c0_get_moves_from_PGN(PGN0);
    printout (mlist0);
    
    printout("moves -> PGN (reverse action)");
	String PGN1=c0_put_to_PGN(mlist0);
    printout (PGN1);
    
    // Show short notation code-decode
    c0_PGN_short=true;
    c0_get_from_PGN(PGN1);	// now c0_PG_sh contains short notation of c0_moveslist
    printout ("Short notation (feature):" + c0_PG_sh);
    c0_short2list();	// converts C0_PG_sh short notation to c0_moveslist moves...
    printout ("(reversed)moveslist=" + c0_moveslist);
    c0_PGN_short=false;
    
    
	//3.Fischerrandom support test (ok):
    printout("Fischer-random  PGN -> moves");
	String PGN3="[White Aronian, Levon][Black Rosa, Mike][Result 0:1][SetUp 1][FEN bbrkqnrn/pppppppp/8/8/8/8/PPPPPPPP/BBRKQNRN w GCgc - 0 0] 1. c4 e5 2. Nhg3 Nhg6 3. b3 f6 4. e3 b6 5. Qe2 Ne6 6. Qh5 Rh8 7. Nf5 Ne7 8. Qxe8+ Kxe8 9. N1g3 h5 10. Nxe7 Kxe7 11. d4 d6 12. h4 Kf7 13. d5 Nf8 14. f4 c6 15. fxe5 dxe5 16. e4 Bd6 17. Bd3 Ng6 18. O-O Nxh4 19. Be2 Ng6 20. Nf5 Bc5+ 21. Kh2 Nf4 22. Rc2 cxd5 23. exd5 h4 24. Bg4 Rce8 25. Bb2 g6 26. Nd4 exd4 27.Rxf4 Bd6 0-1";
	String mlist3=c0_get_moves_from_PGN(PGN3);
    printout (mlist3);

    printout("moves -> PGN (reverse action)");   
    String PGN4=c0_put_to_PGN(mlist3);
    printout (PGN4);
    
    // clear it all
    c0_start_FEN = "";
    c0_set_start_position("");
    printout ("Starting position...");
   
    printout ("Welcome, have a nice day!");
 
}


}