package com.r3chess;

import android.graphics.*;
import android.view.SurfaceHolder;

class r3chessBoard
{
	r3chessActivity A;
	c0_chess C0 = new c0_chess();
	String[] Kn4 = { "b1","g1","b8","g8" };
	boolean Inverted = (Rand10()>4);			// random
	r3chessBoard(r3chessActivity A) { this.A =A; }
	String DragAt = "";
	String MovedAt = "";
	Fruit21 FR = new Fruit21();
	c0_opn OPn = new c0_opn();
	boolean GameOver = false;
	String GenNextMoves = "," + C0.c0_get_next_moves();
	String FRmlist = "";
	float wkf = 0;
	float hkf = 0;
	Object lock = new Object();
	String InfoMess = "";
	
	class FicsData
	{
		boolean FicsGame = false;
		String[][] Board = new String[8][8];
		String InfoMess = "";
		String[] InfoM3 = { "", "", "" };
		String WhiteUserLogin = "";
		String BlackUserLogin = "";
		String WhiteClock = "";
		String BlackClock = "";
		String WhiteStrength = "";
		String BlackStrength = "";
		String currGMove = "";
		String currGMwas = "";
		boolean obsorvingMode = false;
	}
	FicsData Fics = new FicsData();
		
	int Rand10()	// random 1..10
	{
		String rS = Long.toString(System.currentTimeMillis());
		return (rS.charAt(rS.length()-2)-'0');
	}
	
	void AddFicsM3(String fMess)
	{
		Fics.InfoM3[0]=Fics.InfoM3[1];
		Fics.InfoM3[1]=Fics.InfoM3[2];
		Fics.InfoM3[2]= fMess;
	}
	
	void Draw(Canvas c, SurfaceHolder holder)
	{

	    Rect r = holder.getSurfaceFrame();	

	    wkf = r.width();
	    hkf = r.height();

	    BitmapFactory.Options bmpOp = new BitmapFactory.Options();
	    Bitmap bB = BitmapFactory.decodeResource(A.getResources(), R.drawable.bo4, bmpOp );
	    
		wkf/=1228;		// width resizing
		hkf/=1140;		// height resizing
		
		float wkf2 = wkf;
		float hkf2 = hkf;
		if(wkf<1.0f) wkf2*=0.9f;
		if(hkf<1.0f) hkf2*=0.9f;
		if(wkf<0.8f) wkf2*=0.8f;
		if(hkf<0.8f) hkf2*=0.8f;
		if(wkf<0.6f) wkf2*=0.8f;
		if(hkf<0.6f) hkf2*=0.8f;
		if(wkf2>hkf2) wkf2=hkf2; else hkf2=wkf2;
		
		final int
			pA1x = 141, pA1y = 994,		// the centre of A1 square
			pA8x = 206, pA8y = 160,		// the centre of A8 square
			pH1x = 1083, pH1y = 998,	// the centre of H1 square	
			pH8x = 1012, pH8y = 158;	// the centre of H8 square		
		
	    Bitmap bBSz = Bitmap.createScaledBitmap(bB, r.width(), r.height(), true);
	    c.drawBitmap(bBSz, r.left, r.top, null);	    
	    
	    int i,j,q,x,y;
	    String pc,at;
	    String[] BO = new String[64];
	    
	    if(Fics.FicsGame)
	    {
	    	// use data from fics server only
	    	for(j=0;j<64;j++)
	    	{
	    		y=(int)(j>>3);	// vertical square
	    		x=j&7;			// horizontal square
	    		
	    		at = "" + (char)('a'+x) + (char)('1'+y);
	    		pc = Fics.Board[y][x];
	    		BO[j] = pc;
	    		if(pc!=null)
	    		{		
	    		if(pc.charAt(1)=='N')
	    	    {
	    	    for(q=0;q<4;q++) if(Kn4[q].equals(at)) BO[j]+=(char)('0'+q);
	    	    }
	    	    if(DragAt.equals(at)) BO[j]+='*';
	    	    if(MovedAt.equals(at)) BO[j]+='$';
	    		}
	    	}	
	    }
	    else
	    {
	    for(i=0;C0.c0_position.length()>i;i+=5)
	    {
	    	pc = C0.c0_position.substring(i,i+5);
	    	at = pc.substring(2,4);
	    	j = ((pc.charAt(3)-'1')<<3) + (pc.charAt(2)-'a');
	    	BO[j] = pc.substring(0,2);
	    	if(pc.charAt(1)=='N')
	    		{
	    		for(q=0;q<4;q++) if(Kn4[q].equals(at)) BO[j]+=(char)('0'+q);
	    		}
	    	if(DragAt.equals(at)) BO[j]+='*';
	    	if(MovedAt.equals(at)) BO[j]+='$';
	    }
	    }
	    
	    i=(!Inverted ? 63 : 0);
	    for(;i>=0 && i<64;)
	    {
	    	pc = BO[i];
	    	if(pc!=null)
	    	{
	    		int pcId = 0;
	    		float pkf = 1.2f;
	    		
	    		if(pc.charAt(0)=='w')
	    		 {
	    			switch( pc.charAt(1))
	    			{
	    			case 'p':
	    				pcId=R.drawable.wp;
	    				break;
	    			case 'N':
	    				pc+="   ";
	    				if(!Inverted)
	    					{	
	    					pcId= ( pc.charAt(2)=='1' ? R.drawable.wn21 : R.drawable.wn22 );
	    					}
	    				else
    						{	
	    					pcId= ( pc.charAt(2)=='0' ? R.drawable.wn11 : R.drawable.wn12 );	
    						}
    					pkf=1.1f;	    				
	    				break;
	    			case 'B':
	    				pcId=R.drawable.wb;
	    				break;
	    			case 'R':
	    				pcId=R.drawable.wr;
	    				pkf=1.1f;
	    				break;
	    			case 'Q':
	    				pcId=R.drawable.wq;
	    				pkf=1.1f;
	    				break;
	    			case 'K':
	    				pcId=R.drawable.wk;
	    				pkf=1.0f;
	    				break;  			
	    			}
	    		 }
	    		else
	    		 {
	    			switch( pc.charAt(1))
	    			{
	    			case 'p':
	    				pcId=R.drawable.bp;
	    				break;
	    			case 'N':
	    				pc+="   ";
	    				if(!Inverted)
    						{	    				
	    					pcId= ( pc.charAt(2)=='3' ? R.drawable.bn11 : R.drawable.bn12 );
    						}
	    				else
	    					{
	    					pcId= ( pc.charAt(2)=='2' ? R.drawable.bn21 : R.drawable.bn22 );
	    					}
	    				pkf=1.1f;
	    				break;
	    			case 'B':
	    				pcId=R.drawable.bb;
	    				break;
	    			case 'R':
	    				pcId=R.drawable.br;
	    				pkf=1.1f;
	    				break;
	    			case 'Q':
	    				pcId=R.drawable.bq;
	    				pkf=1.1f;
	    				break;
	    			case 'K':
	    				pcId=R.drawable.bk;
	    				pkf=1.0f;	    				
	    				break;  			
	    			}
	    		 }			
	    		
	    		y=(int)(i>>3);	// vertical square
	    		x=i&7;			// horizontal square
	    		
	    		if(!Inverted) y=7-y; else x=7-x;

	    		int p0x = pA1x + ((pA8x-pA1x)*(7-y)/7);
	    		int p0y = pA8y + ((pH8y-pA8y)*x/7);
	    		
	    		int dPx = ((pH1x-pA1x) - (pH8x-pA8x))*y/7;
	    		int pX = p0x + ((dPx + (pH8x-pA8x))*x/7);
	    		
	    		int dPy = ((pH1y-pH8y) - (pA1y-pA8y))*x/7;
	    		int pY = p0y + ((dPy + (pA1y-pA8y))*y/7);
	    		
	    		pY -= (pA1y-pA8y)*(4-(y>4?y-4:4-y))/100;
	    		
	    		pX*=wkf;	// x-coordinate
	    		pY*=hkf;	// y-coordinate
	    		
	    		Bitmap bP = BitmapFactory.decodeResource(A.getResources(), pcId, bmpOp );
	    		int pW = bP.getWidth();
	    		int pH = bP.getHeight();
	    		pkf-=0.15/(y+1);
	    		pW*=wkf2*pkf;
	    		pH*=hkf2*pkf;
	    		
	    		int cursId = 0;
	    		if(pc.indexOf('*')>=0) cursId=R.drawable.el2;
	    		if(pc.indexOf('$')>=0) cursId=R.drawable.el1;
	    		
	    		if(cursId!=0)
	    		{
	    			Bitmap bCP = BitmapFactory.decodeResource(A.getResources(), cursId, bmpOp );
		    		int pCW = bCP.getWidth();
		    		int pCH = bCP.getHeight();
		    		pkf=0.9f;
		    		pkf-=0.15/(y+1);
		    		
		    		pCW*=wkf2*pkf;
		    		pCH*=hkf2*pkf;
		    		
		    		pkf = (1.2f*pW)/pCW;
		    		pCW*=pkf;
		    		pCH*=pkf;
		    		
		    		
		    		Bitmap bpCSz = Bitmap.createScaledBitmap(bCP, pCW, pCH, true);
		    		int pCX = pX; int pCY = pY;
		    		pCX-=pCW/2; pCY-=pCH*4/7;
		    	    c.drawBitmap(bpCSz, r.left+pCX, r.top+pCY, null);
	    		}
	    		
	    		pX-=pW/2; pY-=pH*3/4;
	    		
	    		Bitmap bpSz = Bitmap.createScaledBitmap(bP, pW, pH, true);
	    	    c.drawBitmap(bpSz, r.left+pX, r.top+pY, null);
	    	    
	    	}
	    	
	    	if(!Inverted) i--; else i++;
	    }
	    	    
		Paint pnt = new Paint();
		pnt.setColor(Color.WHITE);
		pnt.setTextSize((int)(32 * hkf));
		pnt.setStyle(Paint.Style.FILL);
		c.drawText(InfoMess, r.left+20, r.top+20, pnt);
		if(Fics.FicsGame)
			{
			pnt.setTextSize((int)(48 * hkf));
			c.drawText(Fics.InfoMess, r.left+20, r.top+40, pnt);
			
			String MyName = ( Inverted ?
					Fics.BlackUserLogin : Fics.WhiteUserLogin );
			String OppName = ( Inverted ?
					Fics.WhiteUserLogin : Fics.BlackUserLogin );				
			String MyClock = ( Inverted ?
					Fics.BlackClock : Fics.WhiteClock );
			String OppClock = ( Inverted ?
					Fics.WhiteClock : Fics.BlackClock );
			
			String MyStrength = ( Inverted ?
					Fics.BlackStrength : Fics.WhiteStrength );
			String OppStrength = ( Inverted ?
					Fics.WhiteStrength : Fics.BlackStrength );
			
			MyName += " (" + MyStrength + ")";
			OppName += " (" + OppStrength + ")";
			
			c.drawText(OppName, r.right-240, r.top+20, pnt);
			c.drawText(MyName, r.right-240, r.bottom-30, pnt);
			
			pnt.setColor(ColorByClock(OppClock));
			c.drawText(OppClock, r.right-60, r.top+20, pnt);
			
			pnt.setColor(Color.BLACK);
			c.drawRect(r.right-80, r.bottom-50, r.right-5, r.bottom-20, pnt);
			
			pnt.setColor(ColorByClock(MyClock));
			c.drawText(MyClock, r.right-60, r.bottom-30, pnt);

			pnt.setColor(Color.WHITE);
			for(int p=0;p<3;p++)
				{
				c.drawText(Fics.InfoM3[p], r.left+20, r.bottom-100+(24*p), pnt);
				}
			
			}
	}
	
	int ColorByClock(String c)
	{
		int a = c.indexOf(':');
		int b = c.lastIndexOf(':');
		if(a>0)
		{
			int m = Integer.parseInt(c.substring(0,a));
			if(b>a)
				{
				if(m>0) return Color.WHITE;
				m = Integer.parseInt(c.substring(a+1,b));
				}
			if(m<=1) return Color.RED;
			if(m<=3) return Color.GREEN;
		}
		return Color.WHITE;
	}
	
	void UpdateInfoMessage()
	{
	String col = (C0.c0_sidemoves>0 ? "w" : "b");
	InfoMess = "";

	if(C0.c0_D_is_check_to_king(col))
		{
		InfoMess = "Check+";
		}

	if(C0.c0_D_is_mate_to_king(col))
		{
		GameOver = true;
		InfoMess = "Checkmate! " + (col.equals("b")?"1-0":"0-1");
		}
	if(C0.c0_D_is_stalemate_to_king(col))
		{
		GameOver = true;
		InfoMess = "Stalemate! " + "1/2-1/2";
		}
	}
	
	boolean MoveIfShould()
	{
		boolean retv = false;
		synchronized(lock)
		{
		if(FR!=null && !GameOver && !Fics.FicsGame )
		  {			  
			  if((C0.c0_sidemoves>0)==Inverted)
			  {
				  DragAt = "";
				  FR.bestmv = "";
				  
				  // try openings
				  String gOpn= OPn.c0_Opening(C0.c0_moveslist);
				  if(gOpn.length()>4)	// some random
				  	{	  
					  int rnd = Rand10();
					  int rnI = 0;
					  while((rnd--)>=0)
					  	{
						  String m = gOpn.substring(rnI,rnI+4);
						  rnI+=9; if(rnI>=gOpn.length()) rnI=0;
						  
						  if(GenNextMoves.indexOf(","+m+",")<0)
							  m = "";	// avoid bad records if are
						  FR.bestmv = m;
					  	}					  
				  	}
						  
				  // otherwise search
				  if( FR.bestmv.length()==0 )
				  {	
					  if(FRmlist.length()>0) FR.do_input("position moves" + FRmlist);
					  FR.do_input("go movetime 6");
				  }
				  
				  if( FR.bestmv.length()>0 )
					  {
					  MOVEDO(FR.bestmv);
					  retv = true;
					  }
			  }
		  }
		}
		return retv;
	}
	
	void MOVEDO(String mv)
	{
		 if(mv.length()>0)
		  {
			  String f1 = mv.substring(0,2);
			  String t1 = mv.substring(2,4);
			  String pc_bef = C0.c0_D_what_at(f1);
			  char p2 = ( mv.length()>4 ? mv.charAt(4) : 'Q' );
				  
			  MovedAt = t1;
			  C0.c0_become_from_engine = ""+p2;
			  C0.c0_become = "";
			  C0.c0_move_to(f1, t1);
			  C0.c0_sidemoves = -C0.c0_sidemoves;

			  String pc_aft = C0.c0_D_what_at(t1);

			  GenNextMoves = "," + C0.c0_get_next_moves();			  
			  
			  FRmlist += " " + mv +
					  (pc_bef.equals(pc_aft) ? "" :
						  pc_aft.toLowerCase().charAt(1));
			  for(int q=0;q<4;q++)
				  {
				  if(Kn4[q].equals(t1)) Kn4[q]="%"+Kn4[q];
				  if(Kn4[q].equals(f1)) Kn4[q]=t1;
				  }
			  
			  if(Fics.FicsGame)		// let's make it faster
			  	{
				 int fy = (f1.charAt(1)-'1');
				 int fx = (f1.charAt(0)-'a');
				 int ty = (t1.charAt(1)-'1');
				 int tx = (t1.charAt(0)-'a');
				 if(Fics.Board[fy][fx]!=null)
				 	{
					 Fics.Board[ty][tx] = Fics.Board[fy][fx];
					 Fics.Board[fy][fx] = null;
				 	}
			  	}
			  
			  UpdateInfoMessage();
		  }
	}
	

	void DOTAKEBACK()
	{
	for(int w=0;w<2;w++)
		{	
		int l = C0.c0_moveslist.length();
		if(l>0)
			{
			String lastwas = C0.c0_D_last_move_was();
			String f1 = lastwas.substring(0,2);
			String t1 = lastwas.substring(2,4);
			for(int q=0;q<4;q++)
			  {
			  if(Kn4[q].equals(t1)) Kn4[q]=f1;
			  if(Kn4[q].equals("%"+t1)) Kn4[q]=t1;
			  }
			  
			C0.c0_take_back();
			GenNextMoves = "," + C0.c0_get_next_moves();
			int l2 = FRmlist.lastIndexOf(' ');
			FRmlist = (l2<=0 ? "" : FRmlist.substring(0, l2));
			DragAt = "";
			MovedAt = (l2>4 ? FRmlist.substring(l2-2,l2): "");
			}
		}
		UpdateInfoMessage();
		GameOver = false;
	}
	
	void mousePressAt(float x, float y)
	{
		final int[]
			pA1H1 =	{70,1064, 203,1063, 337,1064, 473,1063, 608,1064,
				743,1065, 881,1064, 1016,1065, 1148,1061 },
			pA8H8 =	{162,114, 270,113, 382,112, 496,110, 607,110,
				722,109, 835,107, 951,105, 1063,106 },
			pA1A8 =	{70,1063, 84,924, 95,793, 107,666, 119,547,
				129,431, 140,321, 150,215, 165,114},
			pH1H8 =	{1150,1060, 1140,923, 1128,792, 1116,663, 1104,542,
				1094,425, 1082,314, 1073,206, 1063,105 };
		
		synchronized(lock)
		{

		String square = "";

		int v,h, v1,h1;
		for(v=0;v<8;v++)
			for(h=0;h<8;h++)
			{
				h1 = (Inverted ? 7-h : h );
				v1 = (Inverted ? 7-v : v );

				float pxDL = pA1H1[(h<<1)]*wkf;
				float pxDR = pA1H1[(h<<1)+2]*wkf;
				float pxUL = pA8H8[(h<<1)]*wkf;
				float pxUR = pA8H8[(h<<1)+2]*wkf;
				
				float pyDL = pA1A8[(v<<1)+1]*hkf;
				float pyDR = pH1H8[(v<<1)+1]*hkf;
				float pyUL = pA1A8[(v<<1)+3]*hkf;
				float pyUR = pH1H8[(v<<1)+3]*hkf;
				
				float lx= (pxDL+pxUL)/2;
				float rx= (pxDR+pxUR)/2;
				float dy= (pyDL+pyDR)/2;
				float uy= (pyUL+pyUR)/2;
				
				if(x>=lx && x<=rx && y>=uy && y<=dy)
					{
					square ="" + (char)('a'+h1) + (char)('1'+v1);
					h = 9; v = 9;
					
					if(Fics.obsorvingMode)	
						{
						String pcOnSq = C0.c0_D_what_at(square);
						if(pcOnSq.length()>0)
							{
							Inverted = (pcOnSq.charAt(0)=='b');	// swap board
							}
						}
					else
					 {
					 if((!GameOver) && (C0.c0_sidemoves<0)==Inverted &&
							(!square.equals(DragAt)))
						{
						if( GenNextMoves.indexOf(","+square)>=0 ) DragAt = square;
						else
							{
							if( DragAt.length()>0 &&
									GenNextMoves.indexOf(DragAt+square+",")>=0 )
								{
								String move = DragAt+square;
								MOVEDO(move);
								if(Fics.FicsGame) A.TelnetAct2(move); 
								}
							}
						}
					 }
					}
			}
		}
	}
	
	// analyse incoming move from telnet
	boolean FICSmove(String moveStr)
	{
	String move = C0.c0_from_Crafty_standard(moveStr,(C0.c0_sidemoves>0?"w":"b") );
	if(move.length()>0)
		{
		MOVEDO(move);
		return true;
		}
	
	if(Fics.obsorvingMode)
		{
		String c = moveStr;
		if(c.indexOf(MovedAt)<0)
			{
			c = c.replace('+', ' ').replace('#', ' ').trim();
			int l = c.length();
			if(l>2)
				{
				char v = c.charAt(l-1);
				if( ("12345678").indexOf(v)>=0 ) MovedAt = c.substring(l-2,l);
				}
			}
		return true;
		}
	return false;
	}
	
	// verifies Fics current move number of game,
	// is game on board in the same position?
	// correct it, if not the same (after take back, for example)
	boolean FICSverifyGame()
	{
		if(!Fics.obsorvingMode && Fics.currGMove.length()>0)
		{
			String Cw = "[" + Fics.currGMove + "]";
				// verify only if not verified already
			if(Fics.currGMwas.indexOf(Cw)<0) 
			{
			String m = Fics.currGMove;
			int a = m.indexOf('(');
			int moveNumber = Integer.parseInt( m.substring(0,a).trim() );
			int curM = 1;
			int curC = 0;
			final String[] ColStr = { "(White)","(Black)" };
			int l = C0.c0_moveslist.length();
			int i=0;
			boolean moveWas = false;
			
			String lmvdSq_ = "";
			
			Fics.currGMwas += Cw;

			for(;i<l;i+=4)
				{
				lmvdSq_ = C0.c0_moveslist.substring(i+2,i+4);
				if(moveNumber == curM && m.indexOf(ColStr[curC])>=0)
					{
					moveWas = true;
					break;
					}
				if(i+4<l && C0.c0_moveslist.charAt(i+4)=='[') i+=3;
				curM+=curC; curC=curC^1;
				}
			if(i<l)
				{
				C0.c0_set_start_position( C0.c0_moveslist.substring(0,i) );
				GenNextMoves = "," + C0.c0_get_next_moves();
				DragAt = "";
				MovedAt = lmvdSq_;
				return true;
				}
			
			if(!moveWas) return true;		// just redraw, not a good case
				
			}
		}
		else  { A.RefreshFics(); A.RdrwBrd(); }
		
	return false;	
	}
}