package com.r3chess; 

import java.io.*;
import java.net.*;

class r3telnet
{
	Socket Soc;
	DataInputStream DIn;
	DataOutputStream DOut;
	boolean active = false;

	public String ServerName = "";
	public Integer Port = 0;
	
	String inbuffer = "";
	char c13 = (char)13;
	char c10 = (char)10;
	
	boolean CreateSocket()
	{
		active = false;
		try {
			
			//Obtaining IP
			InetAddress IA = InetAddress.getByName(ServerName);
			
			if(Port==0) Port = 5000;
			
			//Create object of Socket
			Soc = new Socket(IA,Port);
			
			//Create object of Input Stream to read from socket
	        DIn=new DataInputStream(Soc.getInputStream());
	        
	        //Create object of Output Stream  to write on socket
	        DOut=new DataOutputStream(Soc.getOutputStream());
	        if( Soc!=null && DIn!=null && DOut!=null) active = true;
		} catch (UnknownHostException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
		return active;
	}
	
	void CloseSocket()
	{   
		try {
			Soc.close();	//close port 
			DIn.close();	//close input stream   
			DOut.close();	//close output stream
			active = false;
			}
		catch (IOException e) { e.printStackTrace();	}
	}
	
	boolean IsInBuffer()		// if string is in buffer
	{
	int q, b = 0;
	
	try { b = DIn.available(); } catch (IOException e) {}
	for(q=0;q<b;q++)
		{
		try {
			inbuffer += (char)DIn.readByte();
			}
		catch (IOException e)	{ e.printStackTrace(); }
		}
	return (inbuffer.indexOf(c13)>=0);
	}
	
	void Send(String cmd)
	{
		try
		{
			DOut.writeUTF(cmd + c13 + c10);
		}
		catch (IOException e) { e.printStackTrace();	}
	}
	
	String ReadLn()
	{
		String r="";
		if(IsInBuffer())
		{
			int q;
			char c;
			for(q=0;q<inbuffer.length();q++)
				{
				c=inbuffer.charAt(q); 
				r+=c;
				if(c==13)
					{
					inbuffer = ( (++q)<inbuffer.length() ? inbuffer.substring(q) : "" );
					break;
					}
				}
		}
		return r;
	}
	
	
	

}